/**
 * Created by jiangcheng on 2016/11/25.
 */
(function (window, bridge) {
    //设置fox javascript bridge
    window.fxBridge=bridge;

}(window, function () {
    //定义桥接对象
    let bridge={

        /**
         * 成功标志
         */
        NOT_RESULT:-1,

        /**
         * 成功标志
         */
        SUCCESS:0,

        /**
         * 取消
         */
        CANCEL:1,

        /**
         * 错误
         */
        ERROR:2,

        /**
         * callback register
         */
        _callbackRegister:{},

        /**
         * 当前索引
         */
        _index: 0,

        /**
         * 最大索引
         */
        _maxIndex: 1000,

        /**
         * 生成索引
         * @private
         */
        _generateId: function () {
            let index = ++this._index;
            if (this._index >= this._maxIndex) {
                this._index = 0;
            }
            return "fx_callback_"+this._index;
        },

        /**
         * 注册回调函数
         * @param pags
         */
        _register: function (args) {
            //创建回调函数
            let fn = (keepCallback, status, data)=>{
                //执行callback
                if(args.callback) {
                    try {
                        args.callback(status, data);
                    } catch (ex) {
                    }
                }
                //是否进度回调
                if(keepCallback && args.process){
                    args.process(data);
                }
                //是否成功回调
                else if(status == this.SUCCESS && args.success){
                    args.success(data);
                }
                //其他为错误回调
                else if(args.error){
                    args.error(data);
                }

            };
            //创建handler
            let handler={
               callback:fn
            };
            //生成ID
            let id=this._generateId();
            //注册handler
            this._callbackRegister[id]=handler;
            //返回id
            return id;
         },

        /**
         * 成功回调
         * @param keepCallback
         * @param callbackId
         * @param status
         * @param args
         */
        callbackFromNative(keepCallback, callbackId, status, args){
            //获取回调函数
            let handler = this._callbackRegister[callbackId];
            //判断是否需要删除回调函数
            if(!keepCallback) {
                //删除回调函数
                delete this._callbackRegister[callbackId];
            }
            //调用回调函数
            handler.callback(keepCallback, status, args);
        },

        /**
         * 执行native
         * @param args
         */
        exec:function(args){
            //定义callback id，如果callback为空白字符串，则代表为同步通信
            let callbackId="";
            //如果是异步调用则
            if(args.async){
                //获取回调ID
               callbackId = this._register(args);
            }
            //转换为字符串
            let argsArray=args.data;
            if(typeof argsArray == "object"){
                argsArray=JSON.stringify(argsArray);
            }
            return _FOX_SYS_BRIDGE.exec(args.service, args.action, argsArray, callbackId);
        }
    };
    return bridge;

}));
