/*这里本项目得工具类方法放置的地方*/

define(function(require,exports){
    //记录exports
    fox.custom=exports;

    /**
     * vue扩展定义方法
     * @param args
     * @returns {*}
     */
    exports.vue=function(args){
        return new Vue(args);
    };

    /**
     * 获取有效数据
     * @param data
     */
    exports.getData=function(data,scope){

        var resData={};

        if(scope){
            for(var key in scope){
                //以m_开头的数据为page中的元数据
                if(key.indexOf("m_")==0){
                    continue;
                }
                resData[key]=data[key];
            }
        }else{
            for(var key in data){
                //以m_开头的数据为page中的元数据
                if(key.indexOf("m_")==0){
                    continue;
                }
                resData[key]=data[key];
            }
        }
        return resData;
    };

    /**
     * 设置数据
     * @param srcData
     * @param targetData
     */
    exports.setData=function(srcData,targetData){
        for(var key in srcData){
            targetData[key]=srcData[key];
        }
        return targetData;
    };

    /**
     * before处理
     * @param parentId(服务页面路由ID)
     * @param currentId(当前页面路由ID)
     * @param vmData(virtual data)
     * @param index(step索引)
     * @return {[type]} [description]
     */
    exports.beforeStep=function(parentId,currentId,vmData,index){
        //获取step options
        let curStepOptions= fox.bus.get(parentId,"stepOptions");
        //判断是否本页面是否已经完成
        if(curStepOptions.finishSteps.indexOf(index)!=-1){
            //获取本页面保存的数据
            let saveData=fox.bus.get(parentId,currentId,"data");
            //同步数据
            fox.custom.setData(saveData,vmData);
        }else{
            //获取本页面保存的数据
            let tempData=fox.bus.get(parentId,currentId,"tempData");
            if(tempData){
                //同步数据
                fox.custom.setData(tempData,vmData);
            }else if(curStepOptions.processSteps.indexOf(index)!=-1){
                //获取本页面保存的数据
                let saveData=fox.bus.get(parentId,currentId,"data");
                //同步数据
                fox.custom.setData(saveData,vmData);
            }
            //保存临时数据
            fox.bus.put(parentId,currentId,"tempData",vmData);
        }
    };

    /**
     * 恢复步骤
     * @return {[type]} [description]
     */
    exports.recoverStep=function(tellerSeq,stepOptions,currentId,serviceName){
        serviceName = serviceName? serviceName:"trade/step/getData";
        //请求服务
        fox.service.request({
            id: 'step_00',
            name: serviceName,
            data: {
                "tellerSeq":tellerSeq
            },
            callback: function (code, message, data) {
                //记录最新的完成index和进行中index
                let lastFinishIndex=1,lastProcessIndex=1;

                if(code == 0 && data && data.subs){
                    for(let i=0;i<stepOptions.steps.length;i++){
                        //获取子业务码
                        let subbusicode=stepOptions.steps[i].subbusicode;
                        //获取子业务数据
                        let subData=data.subs[subbusicode];
                        if(subData){
                            //获取请求数据
                            let reqData=subData["reqdata"];
                            let curIndex=i+1;
                            //获取子页面路由ID
                            let stepRouteId=exports.getStepRouteId(currentId,curIndex);
                            //加入数据
                            fox.bus.put(currentId,stepRouteId,"data",JSON.parse(reqData));
                            if(subData["busistate"]=="1"){
                                stepOptions.finishSteps.push(curIndex);
                                lastFinishIndex=curIndex;
                            }else{
                                stepOptions.processSteps.push(curIndex);
                                lastProcessIndex=curIndex;
                            }
                        }
                    }
                }else{
                    fox.logger.error("还原数据失败,code"+code+", message:"+message);
                    fox.layer.open("还原数据失败");
                }

                if(lastFinishIndex>lastProcessIndex){
                    let stepIndex = lastFinishIndex < stepOptions.steps.length? (lastFinishIndex+1):stepOptions.steps.length;
                    //更新selectStep
                    stepOptions.selectStep=stepIndex;
                }else{
                    //更新selectStep
                    stepOptions.selectStep=lastProcessIndex;
                }
            }
        });
    };

    /**
     * 获取step的路由ID
     * @param  {[type]} id    [description]
     * @param  {[type]} index [description]
     * @return {[type]}       [description]
     */
    exports.getStepRouteId=function(id,index){
        index=index+"";
        if(index.length<2){
            index="0"+index;
        }
        let i=id.indexOf("_");
        let s=id.substring(0,i);
        let routeId=s+"_"+index;
        return routeId;
    };

    /**
     * 移除数组元素
     * @param array
     * @param indexs
     */
    exports.removeArray=function(array,indexs){
        for(var i=array.length-1;i>=0;i--){
            if(this.contains(indexs,i)){
                array.splice(i,1);
            }
        }
    };

    /**
     * 判断元素是否数组中
     * @param array
     * @param itemn
     */
    exports.contains = function(array,item){
        var flag=false;
        for(var i=0;i<array.length;i++){
            if(array[i] === item){
                flag=true;
                break;
            }
        }
        return flag;
    };

    /**
     * 获取document属性
     * @param attrName
     * @returns {number}
     */
    exports.getDocumentAttribute = function getDocumentAttribute(attrName) {
        if (document.compatMode == "BackCompat") {
            var attrValue = 0;
            if ("clientWidth" === attrName) {
                attrValue = document.body.clientWidth;
            } else if ("clientHeight" == attrName) {
                attrValue = document.body.clientHeight;
            } else if ("scrollWidth" == attrName) {
                attrValue = document.body.scrollWidth;
            } else if ("scrollHeight" === attrName) {
                attrValue = document.body.scrollHeight;
            } else if ("scrollLeft" === attrName) {
                attrValue = document.body.scrollLeft;
            } else if ("scrollTop" === attrName) {
                attrValue = document.body.scrollTop;
            }
            return attrValue;
        }
        else { //document.compatMode == "CSS1Compat"
            var attrValue = 0;
            if ("clientWidth" === attrName) {
                attrValue = document.documentElement.clientWidth;
            } else if ("clientHeight" == attrName) {
                attrValue = document.documentElement.clientHeight;
            } else if ("scrollWidth" == attrName) {
                attrValue = document.documentElement.scrollWidth;
            } else if ("scrollHeight" === attrName) {
                attrValue = document.documentElement.scrollHeight;
            } else if ("scrollLeft" === attrName) {
                attrValue = document.documentElement.scrollLeft == 0 ? document.body.scrollLeft : document.documentElement.scrollLeft;
            } else if ("scrollTop" === attrName) {
                attrValue = document.documentElement.scrollTop == 0 ? document.body.scrollTop : document.documentElement.scrollTop;
            }
            return attrValue;
        }
    };

    /**
     * 回到home页面
     */
    exports.goHome = function goHome(){
        //发送消息
        fox.router.sendMessage("frame","home");
    },

        /**
         * 客户识别
         * @requestFlag  客户查询列表传入参数，1 -个人客户，2 -企业客户，3 -所有客户，‘4’主办业务客户查询，‘5’业务关联客户查询
         * @viewRightFlag  是否需要判断权限  true判断 false不判断
         * @checkType  判断权限的方式  '1'：全权限判断 '2'：只判断查看权    其余情况如不判断权限时，次参数传'0'
         * @applyFlag  在没有权限时是否要进行申请权限 true申请 false不申请
         * @businessFlag   业务种类标志,主要用途为从b面客户识别后，选中客户时判断跳转到哪个页面，其余为获取信息而调用时可传""
         * @newCustomerFlag    是否在客户查询列表显示新建客户号    true显示 false不显示
         * @fn 回调函数
         * @smeBusinessType    小微子产品类型，目前小微产品使用，后续住房子产品增加后若有需要，进行调整
         */
        // exports.showCustomerDistinguish=function showCustomerDistinguish(flag,fn,smeBusinessType){
        exports.showCustomerDistinguish=function showCustomerDistinguish(requestFlag,viewRightFlag,checkType,applyFlag,businessFlag,newCustomerFlag,fn,smeBusinessType){

            var index=fox.layer.open({
                type: 1
                , content: "#distinguish"
                , success: function () {
                    fox.bus.remove("showCustomerDistinguish");
                    fox.bus.put("_CustomerDistinguish","requestFlag",requestFlag);
                    fox.bus.put("_CustomerDistinguish","viewRightFlag",viewRightFlag);
                    fox.bus.put("_CustomerDistinguish","checkType",checkType);
                    fox.bus.put("_CustomerDistinguish","applyFlag",applyFlag);
                    fox.bus.put("_CustomerDistinguish","flag",businessFlag);
                    fox.bus.put("_CustomerDistinguish","newCustomerFlag",newCustomerFlag);
                    fox.bus.put("_CustomerDistinguish","callback",fn);
                    fox.bus.put("_CustomerDistinguish","smeBusinessType",smeBusinessType);
                    fox.$("#searchKey").val("");  //初始化查询文本框

                    var fnList=fox.bus.get("_CustomerDistinguish","fnList");
                    if(fnList == void(0)){
                        fnList=[];
                        fnList.push(function(){
                            var i=fox.bus.get("_CustomerDistinguish","index");
                            fox.layer.close(i);
                        });
                        fnList.push(function(){
                            var params={
                                level:"high",
                                tryTimes:50
                            };

                            fox.device.callCamera("back",function(code,message,data){
                                if(code==0){
                                    let jsonData=JSON.parse(data);
                                    let path=jsonData.path;
                                    console.log("图片地址："+path);
                                    let date=new Date();
                                    let param={};
                                    let remoteDatSavePath="upload/customerTempPhoto";
                                    let remoteDatFileName="log-"+date.getYear()+"-"+date.getMonth()+"-"+date.getDay()+"-"+date.getHours()+"-"+date.getMinutes()+".jpg";
                                    let dataPath = remoteDatSavePath+remoteDatFileName;
                                    var uploadFilePath=jsonData.path;
                                    fox.http.upload(remoteDatSavePath, remoteDatFileName, uploadFilePath,param,function(code,message,data){
                                        if(code==0) {
                                            fox.service.request({
                                                id:"customerOCR",
                                                name:"customer/customerDemo/customerOCR",
                                                data:{
                                                    remoteIdPhotoSavePath:remoteDatSavePath,
                                                    remoteIdPhotoFileName:remoteDatFileName
                                                },
                                                callback:function(code,message,data){
                                                    if(code == 0){
                                                        let certType = data.result.cardtype;

                                                        var frontInfoForNewCustomer = {};
                                                        frontInfoForNewCustomer.idForntPath=uploadFilePath;
                                                        //frontInfoForNewCustomer.image = "data:image/png;base64," + jsonData.frontBase64Data;
                                                        frontInfoForNewCustomer.image ="data:image/png;base64," +data.result.paramdata;
                                                        frontInfoForNewCustomer.CustomerName=data.result.姓名;
                                                        frontInfoForNewCustomer.CertID=data.result.公民身份号码;
                                                        frontInfoForNewCustomer.Birthday=data.result.出生;
                                                        frontInfoForNewCustomer.NativePlace1=data.result.住址;
                                                        frontInfoForNewCustomer.Sex=data.result.性别;
                                                        fox.bus.put("showCustomerDistinguish","frontCardInfo",frontInfoForNewCustomer);
                                                        var key= data.result.公民身份号码;

                                                        //判断身份证格式是否正确
                                                        var value = key;
                                                        var regs = /(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
                                                        var mat = value.match(regs);
                                                        if(!!mat){
                                                            value = value.toUpperCase();
                                                            var factor = [7,9,10,5,8,4,2,1,6,3,7,9,10,5,8,4,2];
                                                            var parity = [1,0,'X',9,8,7,6,5,4,3,2];
                                                            var sum = 0;
                                                            var ai = 0;
                                                            var wi = 0;
                                                            value = value.split("");
                                                            for(var i = 0;i < 17;i++){
                                                                ai = value[i];
                                                                wi = factor[i];
                                                                sum += ai * wi;
                                                            }
                                                            if(parity[sum % 11] == value[17]){

                                                            }else{
                                                                return fox.layer.open("读取身份证号码格式错误，请重新识别");
                                                            }
                                                        }

                                                        var flag=fox.bus.get("_CustomerDistinguish","flag");
                                                        var callback = fox.bus.get("_CustomerDistinguish","callback");
                                                        var params={
                                                            requestFlag:fox.bus.get("_CustomerDistinguish","requestFlag"),
                                                            viewRightFlag:fox.bus.get("_CustomerDistinguish","viewRightFlag"),
                                                            checkType:fox.bus.get("_CustomerDistinguish","checkType"),
                                                            applyFlag:fox.bus.get("_CustomerDistinguish","applyFlag"),
                                                            businessFlag:  flag,
                                                            newCustomerFlag:fox.bus.get("_CustomerDistinguish","newCustomerFlag"),
                                                            key:key,
                                                            smeBusinessType:fox.bus.get("_CustomerDistinguish","smeBusinessType")?fox.bus.get("_CustomerDistinguish","smeBusinessType"):""

                                                        };
                                                        if(flag==="SME"){
                                                            fox.router.to("customerListFrame",params);
                                                        }else if(flag==="Housing"||flag==="CL"||flag==="PCCL" ||flag==="PCCL1"){
                                                            fox.router.to("customerListFrame",params);
                                                        }else{
                                                            //目前此处均为弹窗引用，若后续有变化请及时作出调整并修改备注
                                                            fox.custom.showCustomerList(params,callback);
                                                        }
                                                        fox.$("#searchKey").val("");
                                                        var i=fox.bus.get("_CustomerDistinguish","index");
                                                        fox.layer.close(i);

                                                    }else{
                                                        fox.layer.open("身份证识别失败");
                                                    }
                                                }
                                            });
                                        }else{
                                            //fox.layer.close(id);
                                            fox.layer.open("上传失败:"+message)
                                        }
                                    });
                                }else{
                                    //fox.layer.open("取消调用相机...");
                                }
                            },params);
                            //OCR
                            /*  fox.device.callOcr("front",function (code, message, data) {
                                  if (code == 0) {
                                      var frontInfoForNewCustomer = {};
                                      var jsonData = JSON.parse(data);
                                      frontInfoForNewCustomer.idForntPath=jsonData.frontPath;
                                      frontInfoForNewCustomer.image = "data:image/png;base64," + jsonData.frontBase64Data;
                                      frontInfoForNewCustomer.CustomerName=jsonData.name;
                                      frontInfoForNewCustomer.CertID=jsonData.id;
                                      frontInfoForNewCustomer.Birthday=jsonData.birthday.replace(/-/g,"/");
                                      frontInfoForNewCustomer.NativePlace1=jsonData.address;
                                      frontInfoForNewCustomer.Sex=jsonData.sex;
                                      fox.bus.put("showCustomerDistinguish","frontCardInfo",frontInfoForNewCustomer);

                                      var key= JSON.parse(data).id;

                                      //判断身份证格式是否正确
                                      var value = key;
                                      var regs = /(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
                                      var mat = value.match(regs);
                                      if(!!mat){
                                          value = value.toUpperCase();
                                          var factor = [7,9,10,5,8,4,2,1,6,3,7,9,10,5,8,4,2];
                                          var parity = [1,0,'X',9,8,7,6,5,4,3,2];
                                          var sum = 0;
                                          var ai = 0;
                                          var wi = 0;
                                          value = value.split("");
                                          for(var i = 0;i < 17;i++){
                                              ai = value[i];
                                              wi = factor[i];
                                              sum += ai * wi;
                                          }
                                          if(parity[sum % 11] == value[17]){

                                          }else{
                                              return fox.layer.open("读取身份证号码格式错误，请重新识别");
                                          }
                                      }

                                      var flag=fox.bus.get("_CustomerDistinguish","flag");
                                      var callback = fox.bus.get("_CustomerDistinguish","callback");
                                      var params={
                                          requestFlag:fox.bus.get("_CustomerDistinguish","requestFlag"),
                                          viewRightFlag:fox.bus.get("_CustomerDistinguish","viewRightFlag"),
                                          checkType:fox.bus.get("_CustomerDistinguish","checkType"),
                                          applyFlag:fox.bus.get("_CustomerDistinguish","applyFlag"),
                                          businessFlag:  flag,
                                          newCustomerFlag:fox.bus.get("_CustomerDistinguish","newCustomerFlag"),
                                          key:key,
                                          smeBusinessType:fox.bus.get("_CustomerDistinguish","smeBusinessType")?fox.bus.get("_CustomerDistinguish","smeBusinessType"):""

                                      };
                                      if(flag==="SME"){
                                          fox.router.to("customerListFrame",params);
                                      }else if(flag==="Housing"||flag==="CL"||flag==="PCCL" ||flag==="PCCL1"){
                                          fox.router.to("customerListFrame",params);
                                      }else{
                                          //目前此处均为弹窗引用，若后续有变化请及时作出调整并修改备注
                                          fox.custom.showCustomerList(params,callback);
                                      }
                                      fox.$("#searchKey").val("");
                                      var i=fox.bus.get("_CustomerDistinguish","index");
                                      fox.layer.close(i);
                                  } else {
                                      fox.layer.open("ocr调用失败:" + message);
                                  }
                              },params)*/
                        });
                        fnList.push(function(){
                            fox.device.callIdr("read",function (code, message, data) {
                                if (code == 0) {
                                    //存储背夹读取信息
                                    var allInfoForNewCustomer = {};
                                    var jsonData = JSON.parse(data);
                                    allInfoForNewCustomer.idForntPath=jsonData.frontPath;
                                    allInfoForNewCustomer.image = "data:image/png;base64," + jsonData.frontBase64Data;
                                    allInfoForNewCustomer.CustomerName=jsonData.name;
                                    allInfoForNewCustomer.CertID=jsonData.idNumber;
                                    allInfoForNewCustomer.Birthday=jsonData.birthday.substring(0,4)+"-"+jsonData.birthday.substring(4,6)+"-"+jsonData.birthday.substring(6,8);
                                    allInfoForNewCustomer.NativePlace1=jsonData.address;
                                    allInfoForNewCustomer.Sex=jsonData.sex;
                                    allInfoForNewCustomer.ProclaimOrg=jsonData.issuer;
                                    var date = jsonData.valid;
                                    allInfoForNewCustomer.CertDate= date.substring(9,13)+"-"+date.substring(13,15)+"-"+date.substring(15,17);
                                    //引用类型标注位
                                    var flag=fox.bus.get("_CustomerDistinguish","flag");
                                    //当前日期
                                    var curDate = "";
                                    //获取用户信息
                                    var timeParam = {};
                                    fox.service.request({
                                        id: "getServerTime",
                                        name: "trade/housing2/getServerTime",
                                        data: timeParam,
                                        callback: function (code, message, data) {
                                            if (code == 0 || code==undefined) {
                                                curDate = data.date;
                                            } else {
                                                fox.layer.open(JSON.stringify(message));
                                                fox.router.to("second");
                                            }
                                        }
                                    });
                                    if(curDate>=allInfoForNewCustomer.CertDate){
                                        fox.layer.open("身份证有效期为：" + allInfoForNewCustomer.CertDate + "，已过期");
                                        if(flag=="SME"||flag=="Housing"||flag=="CL"||flag=="PCCL" ||flag=="PCCL1"){
                                            fox.router.to("second");
                                        }
                                    }
                                    //背夹读取标识
                                    allInfoForNewCustomer.disFlag=true;
                                    //存储信息
                                    fox.bus.put("showCustomerDistinguish","idCardInfo",allInfoForNewCustomer);

                                    var idNumber=JSON.parse(data).idNumber;

                                    var callback = fox.bus.get("_CustomerDistinguish","callback");
                                    var params={
                                        requestFlag:fox.bus.get("_CustomerDistinguish","requestFlag"),
                                        viewRightFlag:fox.bus.get("_CustomerDistinguish","viewRightFlag"),
                                        checkType:fox.bus.get("_CustomerDistinguish","checkType"),
                                        applyFlag:fox.bus.get("_CustomerDistinguish","applyFlag"),
                                        businessFlag:  flag,
                                        newCustomerFlag:fox.bus.get("_CustomerDistinguish","newCustomerFlag"),
                                        key: idNumber,
                                        smeBusinessType:fox.bus.get("_CustomerDistinguish","smeBusinessType")
                                    };
                                    if(flag==="SME"){
                                        fox.router.to("customerListFrame",params);
                                    }else if(flag==="Housing"||flag==="CL"||flag==="PCCL" || flag==="PCCL1"){
                                        fox.router.to("customerListFrame",params);
                                    }else{
                                        //目前此处均为弹窗引用，若后续有变化请及时作出调整并修改备注
                                        fox.custom.showCustomerList(params,callback);
                                    }
                                    fox.$("#searchKey").val("");
                                    var i=fox.bus.get("_CustomerDistinguish","index");
                                    fox.layer.close(i);
                                } else {
                                    fox.layer.open("二代证调用失败:" + message);
                                }
                            })
                        });
                        fnList.push(function(){
                            //调用函数
                            var flag=fox.bus.get("_CustomerDistinguish","flag");
                            var callback = fox.bus.get("_CustomerDistinguish","callback");
                            var params={
                                requestFlag:fox.bus.get("_CustomerDistinguish","requestFlag"),
                                viewRightFlag:fox.bus.get("_CustomerDistinguish","viewRightFlag"),
                                checkType:fox.bus.get("_CustomerDistinguish","checkType"),
                                applyFlag:fox.bus.get("_CustomerDistinguish","applyFlag"),
                                businessFlag:  flag,
                                newCustomerFlag:fox.bus.get("_CustomerDistinguish","newCustomerFlag"),
                                key: fox.$("#searchKey").val(),
                                smeBusinessType:fox.bus.get("_CustomerDistinguish","smeBusinessType")
                            };
                            if(flag==="SME"){
                                fox.router.to("customerListFrame",params);
                            }else if(flag==="Housing"||flag==="CL"||flag==="PCCL" || flag==="PCCL1"){
                                fox.router.to("customerListFrame",params);
                            }else{
                                //目前此处均为弹窗引用，若后续有变化请及时作出调整并修改备注
                                fox.custom.showCustomerList(params,callback);
                                /* let defaultRootID = fox.router.getDefaultRootId();
                                 fox.router.append("customerQuery",params,defaultRootID,{
                                     callback:()=>{
                                         callback();
                                     }
                                 });*/
                            }
                            fox.$("#searchKey").val("");
                            var i=fox.bus.get("_CustomerDistinguish","index");
                            fox.layer.close(i);
                        });
                        fox.bus.put("_CustomerDistinguish","fnList",fnList);
                    }else{
                        //注销事件
                        fox.$("#distinguish").off("close",fnList[0]);
                        fox.$("#ocrRead").off("tap",fnList[1]);
                        fox.$("#idrRead").off("tap",fnList[2]);
                        fox.$("#search").off("tap",fnList[3]);
                    }
                    //注册事件
                    fox.$("#distinguish").on("close",fnList[0]);
                    fox.$("#ocrRead").tap(fnList[1]);
                    fox.$("#idrRead").tap(fnList[2]);
                    fox.$("#search").tap(fnList[3]);

                }
            });
            fox.bus.put("_CustomerDistinguish","index",index);

        };

    /**
     * 客户列表弹窗
     * @flag
     */
    exports.showCustomerList=function showCustomerList(params,fn){
        var index=fox.layer.open({
            type: 1
            , content: "#customerList"
            , success: function () {
                params.callback=function(data){
                    fn.call(this,data);
                    fox.layer.close(index);
                };
                // params.page_options={
                //     contentHeight:"23rem"
                // };
                params.table_height="23rem";
                fox.router.to("customerQuery",params,"_customerQuery_Div");
            }
        });
        fox.bus.put("app","showCustomerList","index",index);
    };

    /**
     * 新建客户弹窗
     * @flag
     */
    exports.showNewCustomer=function showNewCustomer(params,fn){
        var index=fox.layer.open({
            type: 1
            , content: "#_newCustomer_dialog"
            , success: function () {
                params.callback=function(data){
                    fn.call(this,data);
                    fox.layer.close(index);
                };
                fox.router.to("newCustomer",params,"_newCustomer_Div");
            }
        });
        fox.sessionStorage.put("newCustomer",index);
    };
    /**
     * 新建企业客户弹窗
     * @flag
     */
    exports.showNewEnterprise=function showNewEnterprise(params,fn){
        var index=fox.layer.open({
            type: 1
            , content: "#_newBusCustomer_dialog"
            , success: function () {
                params.callback=function(data){
                    fn.call(this,data);
                    fox.layer.close(index);
                };
                fox.router.to("newBusCustomer",params,"_newBusCustomer_Div");
            }
        });
        fox.sessionStorage.put("newBusCustomer",index);
    };

    /**
     * 操作确认弹窗
     * @param title     弹窗标题
     * @param content   弹窗正文
     * @param fnEnsure  点击确认后的回调
     */
    exports.showMyConfirm = function showMyConfirm(title,content,fnEnsure) {
        var layerIndex = fox.layer.open({
            content: content
            , btn: ['取消', '确定']
            //, btn: ['确定', '取消']

            ,action:[
                function(){
                    //取消
                    fox.layer.close(layerIndex);
                },
                function(){
                    //确定
                    fnEnsure();
                    fox.layer.close(layerIndex);
                }
            ]

            //, yes: function(){
            //    fnEnsure();
            //    fox.layer.close(layerIndex);
            //}
            //, no: function (index) {
            //    fox.layer.close(layerIndex);
            //}
        });
        // var params = {
        //     "title":title,
        //     "content":content
        // };
        // fox.bus.put("frame","confirm","fn",fnEnsure);
        // fox.eventproxy.trigger("_frame_confirm",params);
    };
    /**
     * 记录位置信息（测试专用）
     * @param userId
     * @param userName
     * @param remark
     */
    exports.moniPosition = function moniPosition(userId,userName,remark){
        var Address="广东省佛山市南海区南海大道北26号";
        var locationInfoArr = fox.bus.get("frame","locationInfo");
        if(locationInfoArr==undefined){
            locationInfoArr = [];
        }
        //位置坐标
        var CoorDinate="113.140537,23.053092";
        //记录位置的时间
        var date = new Date();
        var month = (date.getMonth()+1)<10?"0" + (date.getMonth()+1):date.getMonth()+1;
        var dateStr = date.getDate()<10?"0" + date.getDate():date.getDate();
        var hours = date.getHours()<10?"0" + date.getHours():date.getHours();
        var minutes = date.getMinutes()<10?"0" + date.getMinutes():date.getMinutes();
        var seconds = date.getSeconds()<10?"0" + date.getSeconds():date.getSeconds();

        var signDate = date.getFullYear() + "-" + month + "-" + dateStr;
        var signTime = hours + ":" + minutes + ":" + seconds;
        var param = {
            address:Address,
            signDate:signDate,
            signTime:signTime,
            coorDinate:CoorDinate
        };
        locationInfoArr.push(param);
        var params = {
            userId:userId,
            userName:userName,
            remark:remark,
            locationInfo:locationInfoArr
        };
        fox.service.request({
            id:"savePositionInfo",
            name:"checkAttendance/checkAttendanceDemo/savePositionInfo",
            data:params,
            callback:function (code,message,data) {
                if(code==0||code==undefined){
                    //如果保存成功，则将内存中的地址信息删除
                    locationInfoArr = [];
                    fox.bus.put("frame","locationInfo",locationInfoArr);
                }else{
                    if(locationInfoArr.length>=20){
                        locationInfoArr = locationInfoArr[20];
                    }
                    fox.bus.put("frame","locationInfo",locationInfoArr);
                    fox.logger.error("记录"+userId+"的位置信息失败:"+message);
                }
            }
        })
    };
    /**
     * 记录当前位置信息
     * @param userId
     * @param userName
     * @param remark
     */
    exports.savePosition = function savePosition(userId,userName,remark){
        fox.native.getLocation(function(code,message,data){
            if(code==0){
                //第一步：获取地址信息
                var Address=JSON.parse(data).addrStr;
                //第二步：判断是否超过上限值(预定上限值为50)
                var locationInfoArr = fox.bus.get("frame","locationInfo");
                if(locationInfoArr==undefined){
                    locationInfoArr = [];
                }
                //位置坐标
                var CoorDinate=JSON.parse(data).longitude+","+JSON.parse(data).latitude;
                //记录位置的时间
                var date = new Date();
                var month = (date.getMonth()+1)<10?"0" + (date.getMonth()+1):date.getMonth()+1;
                var dateStr = date.getDate()<10?"0" + date.getDate():date.getDate();
                var hours = date.getHours()<10?"0" + date.getHours():date.getHours();
                var minutes = date.getMinutes()<10?"0" + date.getMinutes():date.getMinutes();
                var seconds = date.getSeconds()<10?"0" + date.getSeconds():date.getSeconds();

                var signDate = date.getFullYear() + "-" + month + "-" + dateStr;
                var signTime = hours + ":" + minutes + ":" + seconds;
                fox.logger.info("记录日期：" + signDate);
                fox.logger.info("记录时间：" + signTime);
                var param = {
                    address:Address,
                    signDate:signDate,
                    signTime:signTime,
                    coorDinate:CoorDinate
                };
                locationInfoArr.push(param);
                var params = {
                    userId:userId,
                    userName:userName,
                    remark:remark,
                    locationInfo:locationInfoArr
                };
                fox.service.request({
                    id:"savePositionInfo",
                    name:"checkAttendance/checkAttendanceDemo/savePositionInfo",
                    data:params,
                    callback:function (code,message,data) {
                        if(code==0||code==undefined){
                            //如果保存成功，则将内存中的地址信息删除
                            locationInfoArr = [];
                            fox.bus.put("frame","locationInfo",locationInfoArr);
                        }else{
                            if(locationInfoArr.length>=20){
                                locationInfoArr = locationInfoArr[20];
                            }
                            fox.bus.put("frame","locationInfo",locationInfoArr);
                            fox.logger.error("记录"+userId+"的位置信息失败:"+message);
                        }
                    }
                })
            }else{
                fox.logger.error("获取坐标信息失败:"+message);
            }
        })

    };

    /**
     * items(图片列表{text:标题,image:图片路径})
     * @param items
     */
    exports.toggleImageBoard=function toggleImageBoard(items){
        fox.eventproxy.trigger("_sys_image_board",items);
    };

    /**
     * 获取路径
     * @param serialNo
     * @param type
     * @param fileName
     */
    exports.getFilePath = function(serialNo,type,fileName){
        //获取日期
        var date=fox.sessionStorage.get("date");
        if(!date){
            date=new Date().format("yyyyMMdd");
        }
        if(!fileName){
            fileName=new Date().getTime();
        }
        var path=date+"/"+serialNo+"/"+type+"/"+fileName;
        return path;
    };

    //文远程件根目录
    var remoteRoot = "upload";

    //export remote root
    exports._remoteRoot=remoteRoot;

    /**
     * 上传文件
     * @param filePath
     */
    exports.upload=function(filePath,callback,tip){
        if(!tip){
            tip="文件上传中"
        }
        //打开progress
        var id=fox.layer.open({
            type:4,
            content:tip
        });
        //创建回调函数
        var fn=function(code,message,data){
            if(code==0) {
                data=JSON.parse(data);
                var index = data["index"];
                var count = data["totalCount"];
                var n = 100 * index / count;
                n= Math.ceil(n);
                fox.layer.update(id, n);

                if (index == count) {
                    //为了美观延时关闭
                    setTimeout(function(){
                        fox.layer.close(id);
                    },10);

                    //回调成功函数
                    callback(0,"","");
                }
            }else{
                fox.layer.close(id);
                //回调失败函数
                callback(2,message,"");
            }
        };

        var uploadFilePath = fox.$.getAbsolutePath(filePath);
        var timeout=-1;
        //单位为KB
        var pageSize=1024*2;
        let params={
            timeout:timeout,
            async:true,
            cover:false
        };
        try {
            fox.http.breakpointUpload(remoteRoot, filePath, uploadFilePath, pageSize, params, fn);
        }catch(ex){
            fox.logger.error(ex.Message,ex);
            fn(2,ex.message,"");
        }
    };

    /**
     * 下载文件
     * @param filePath
     */
    exports.download=function(filePath, callback, tip, localDir, fileService){
        var id;
        if(tip) {
            //loading带文字
            id = fox.layer.open({
                type: fox.layer.Cover
                , content: tip,
                shadeClose: false
            });
        }
        var fn=function(code,message,data){
            if(code==0) {
                data=JSON.parse(data);
                var index = data["index"];
                var count = data["totalCount"];
                if(id != void(0)) {
                    var n = 100 * index / count;
                    n= Math.ceil(n);
                    fox.layer.update(id, n);
                }
                if (index == count) {
                    if(id != void(0)) {
                        //为了美观延时关闭
                        setTimeout(function () {
                            fox.layer.close(id);
                        }, 10);
                    }
                    //回调成功函数
                    callback(0,"","");
                }
            }else{
                if(id != void(0)) {
                    fox.layer.close(id);
                }
                //回调失败函数
                callback(2,message,"");
            }
        };

        var root=localDir||"";
        var saveFilePath = fox.$.getAbsolutePath(root+filePath);
        var remotePath=remoteRoot+"/"+filePath;
        var timeout=-1;
        let params={
            timeout:timeout,
            async:true,
            cover:false
        };
        if(fileService){
            params.fileService=fileService;
        }

        //单位为KB
        var pageSize=1024*2;
        try {
            fox.http.breakpointDownload(remotePath, saveFilePath, pageSize, params, fn);
        }catch(ex){
            fox.logger.error(ex.message,ex);
            fn(2,ex.Message,"");
        }
    };

    /**
     * 队列上传文件
     * @param uploadFileList
     * @param callback
     * @param tip
     */
    exports.queueUpload=function(uploadFileList,callback,tip,remoteFileLists){
        //自定义目录remoteFileLists
        if(remoteFileLists ==""||remoteFileLists==undefined){
            //远程目录列表
            var remoteFileList=[];
            //文件目录
            for(var i=0;i<uploadFileList.length;i++){
                //获取远端目录
                var s=fox.$.getRelativePath(uploadFileList[i]);
                remoteFileList.push(s);
                //获取本地目录
                uploadFileList[i] = fox.$.getAbsolutePath(uploadFileList[i]);
            }
        }else{
            var remoteFileList = [];
            //文件目录
            for(var i=0;i<uploadFileList.length;i++){
                //获取远端目录
                var s=fox.$.getRelativePath(remoteFileLists[i]);
                remoteFileList.push(s);
                //获取本地目录
                uploadFileList[i] = fox.$.getAbsolutePath(uploadFileList[i]);
            }
        }

        //队列上传文件
        return fox.http.queueUpload(remoteRoot,remoteFileList,uploadFileList,callback,tip,-1)
    };

    /**
     * 队列下载文件
     * @param downloadFileList
     * @param callback
     * @param tip
     * @param savePath
     * @param thumbnail
     * @param fileService
     */
    exports.queueDownload=function(downloadFileList, callback, tip, savePath, thumbnail, fileService){
        let saveFileList;
        if(!savePath || fox.type(savePath) == "string"){
            let root=savePath||"";
            saveFileList=[];
            for(let i=0;i<downloadFileList.length;i++){
                //获取本地目录
                saveFileList.push(fox.$.getAbsolutePath(root+downloadFileList[i]));
                //加入根目录
                downloadFileList[i]=remoteRoot+"/"+downloadFileList[i];
            }
            let params={};
            if(fileService){
                params.fileService = fileService;
            }

            //队列下载文件
            return fox.http.queueDownload(downloadFileList, saveFileList, callback, tip, -1, params)
        }else{
            saveFileList = savePath;
            for (let i = 0; i < downloadFileList.length; i++) {
                saveFileList[i] = fox.$.getAbsolutePath(saveFileList[i])
                if (!downloadFileList[i].startsWith("http")) {
                    //加入根目录
                    downloadFileList[i] = remoteRoot + "/" + downloadFileList[i];
                }
            }
            let params = {
                thumbnail:thumbnail,
            }
            if(fileService){
                params.fileService = fileService;
            }
            //队列下载文件
            return fox.http.queueDownload(downloadFileList, saveFileList, callback, tip, -1, params);
        }

    };

    /**
     * 非程序目录文件上传
     * @param localList
     * @param remoteList
     * @param callback
     * @param tip
     */
    exports.queueUploadForOther =function(localList,remoteList,callback,tip){
        //如果为字符串转换为数组
        if(fox.type(localList) == "string"){
            localList=[localList];
        }

        //格式化remoteList
        if(fox.type(remoteList) == "string"){
            var root=remoteList;
            remoteList=[];
            for(var i=0;i<localList.length;i++){
                var index=localList[i].lastIndexOf("/");
                var fileName=index!=-1? localList[i].substring(index+1):i+"";
                remoteList.push(root+"/"+fileName);
            }
        }
        //队列上传文件
        fox.http.queueUpload(remoteRoot,remoteList,localList,callback,tip,-1)
    };

    /**
     * 队列下载文件(异步)
     * @param downloadFileList
     * @param callback
     * @param tip
     * @param savePath
     * @param thumbnail
     * @param fileService
     * @returns {*}
     */
    exports.aSynQueueDownload = function(downloadFileList, callback, tip, savePath, thumbnail, fileService) {

        let saveFileList;
        if(!savePath || fox.type(savePath) == "string"){
            let root=savePath||"";
            saveFileList=[];
            for(let i=0;i<downloadFileList.length;i++){
                //获取本地目录
                saveFileList.push(fox.$.getAbsolutePath(root+downloadFileList[i]));
                //加入根目录
                downloadFileList[i]=remoteRoot+"/"+downloadFileList[i];
            }
            let params={};
            if(fileService){
                params.fileService = fileService;
            }

            //队列下载文件
            return fox.http.queueDownload(downloadFileList, saveFileList, callback, tip, -1, params)
        }else{
            saveFileList = savePath;
            for (let i = 0; i < downloadFileList.length; i++) {
                saveFileList[i] = fox.$.getAbsolutePath(saveFileList[i])
                if (!downloadFileList[i].startsWith("http")) {
                    //加入根目录
                    downloadFileList[i] = remoteRoot + "/" + downloadFileList[i];
                }
            }
            let params = {
                thumbnail:thumbnail,
            }
            if(fileService){
                params.fileService = fileService;
            }
            //队列下载文件
            return fox.http.queueDownload(downloadFileList, saveFileList, callback, tip, -1, params);
        }

    };

    /**
     * 静默上传队列
     * @constructor
     */
    function SilentUploadQueue(remoteDir,timeout){
        //创建静默上传列表
        this.silentUploadQueue=new fox.http.silentUploadQueue(remoteDir,timeout);
    }

    /**
     * 加入上传文件队列
     * @param localList
     */
    SilentUploadQueue.prototype.add=function add(localList){
        if(fox.type(localList) == "string"){
            localList=[localList];
        }
        //远程目录列表
        var remoteList=[];
        //文件目录
        for(var i=0;i<localList.length;i++){
            //获取远端目录
            var s=fox.$.getRelativePath(localList[i]);
            remoteList.push(s);
            //获取本地目录
            localList[i] = fox.$.getAbsolutePath(localList[i]);
        }
        this.silentUploadQueue.add(remoteList,localList);
        return this;
    };

    /**
     * 加入上传文件队列
     * @param localList
     * @param remoteList
     */
    SilentUploadQueue.prototype.addFromOther=function add(localList,remoteList){
        //如果为字符串转换为数组
        if(fox.type(localList) == "string"){
            localList=[localList];
        }

        //格式化remoteList
        if(fox.type(remoteList) == "string"){
            var root=remoteList;
            remoteList=[];
            for(var i=0;i<localList.length;i++){
                var index=localList[i].lastIndexOf("/");
                var fileName=index!=-1? localList[i].substring(index+1):i+"";
                remoteList.push(root+"/"+fileName);
            }
        }
        //队列上传文件
        this.silentUploadQueue.add(remoteList,localList);
        return this;
    };

    /**
     * 加入上传文件队列（现场调查）
     * @param localList
     * @param remoteList
     */
    SilentUploadQueue.prototype.addSite=function add(localList,remoteList){
        //如果为字符串转换为数组
        if(fox.type(localList) == "string"){
            localList=[localList];
        }

        //格式化remoteList
        if(fox.type(remoteList) == "string"){
            remoteList=[remoteList];
        }
        //队列上传文件
        this.silentUploadQueue.add(remoteList,localList);
        return this;
    };

    /**
     * 下一个上传动作
     */
    SilentUploadQueue.prototype.next=function next(){
        this.silentUploadQueue.next();
        return this;
    };

    /**
     * 重试
     */
    SilentUploadQueue.prototype.retry=function retry(){
        this.silentUploadQueue.retry();
        return this;
    };

    /**
     * 判断是否已经完成上传队列
     */
    SilentUploadQueue.prototype.isFinished=function isFinished(){
        return this.silentUploadQueue.isFinished();
    };

    /**
     * 判断是否成功上传
     */
    SilentUploadQueue.prototype.isSuccess=function isSuccess(){
        return this.silentUploadQueue.isSuccess();
    };

    /**
     * 转换为json对象
     */
    SilentUploadQueue.prototype.toJsonObject = function toJsonObject(){
        return this.silentUploadQueue.toJsonObject();
    };

    /**
     * 从json对象还原
     */
    SilentUploadQueue.prototype.fromJsonObject = function fromJsonObject(){
        return this.silentUploadQueue.fromJsonObject();
    };

    /**
     * 获取成功数量
     */
    SilentUploadQueue.prototype.getSuccessTaskNum=function isSuccess(){
        return this.silentUploadQueue.getSuccessTaskNum();
    };

    /**
     * 获取总数量
     * @returns {*}
     */
    SilentUploadQueue.prototype.getTotalTaskNum=function isSuccess(){
        return this.silentUploadQueue.getTotalTaskNum();
    };

    /**
     * 注册队列上传完成回调函数
     * @param fn
     */
    SilentUploadQueue.prototype.wait=function wait(fn,tip){
        this.silentUploadQueue.wait(fn,tip);
        return this;
    };

    /**
     * 获取静默上传队列
     * @param remoteDir
     * @param timeout
     * @returns {SilentUploadQueue}
     */
    exports.silentUploadQueue=function silentUploadQueue(timeout){
        return new SilentUploadQueue(remoteRoot,timeout);
    };


    /**
     * pad后退键注册方法
     */
    exports.logout = function () {

    }
    /**
     * 各级审批意见查询列表
     * @argument{
     * 业务流水(必传)
     * SerialNo:
     * 业务类型
     * ObjectType
     * 流程编号
     * FlowNo
     * 阶段编号
     * PhaseNo
     * 当前审批流水
     * FlowTaskNo
     * UserID
     * }
     */
    exports.showApprovalDetails=function showApprovalDetails(argument){
        var index;
        var _this=this;
        var adviceList;
        var tellerInfo = fox.sessionStorage.get("tellerInfo");
        var params={
            //业务流水
            ObjectNo:argument.SerialNo,
            //业务类型
            ObjectType:argument.ObjectType,
            //流程编号
            FlowNo:argument.FlowNo,
            //阶段编号
            PhaseNo:argument.PhaseNo,
            //当前审批流水
            TaskNo:argument.FlowTaskNo,
            UserID:argument.UserID,
        }
        if(argument.ObjectType===null||argument.ObjectType===""||argument.ObjectType===undefined){
            params.ObjectType="CreditApply";
        }
        if(argument.UserID===null||argument.UserID===""||argument.UserID===undefined){
            params.UserID=tellerInfo.userId;
        }
        fox.service.request({
            id: "apploveSearch",
            name: "approve/approveSpace/apploveSearch",
            data:params,
            callback: function (code, message, data) {
                //console.log("业务明细意见列表查询"+params.TaskNo);
                adviceList=[];
                if (code == 0 || code == undefined) {
                    console.log(data);

                    //业务意见列表
                    if(data.result.PhaseList){

                        for(var i=0;i<data.result.PhaseList.length;i++){
                            var Color;
                            switch((i+1)%5)
                            {
                                case 0:
                                    Color="#ef5b4c";
                                    break;
                                case 1:
                                    Color="#7aa8e1";
                                    break;
                                case 2:
                                    Color="#54cddf";
                                    break;
                                case 3:
                                    Color="#4cd580";
                                    break;
                                case 4:
                                    Color="#f6cd60";
                                    break;
                            }
                            var a=[];
                            for(var j=0;j<data.result.PhaseList[i].BusinessOpinionList.length;j++){
                                a.push([
                                    /* data.result.PhaseList[i].BusinessOpinionList[j].FObjectNo,*/
                                    {text:data.result.PhaseList[i].BusinessOpinionList[j].FCustomerName,style:"width:11%"},
                                    {text:data.result.PhaseList[i].BusinessOpinionList[j].FBusinessTypeName,style:"width:11%"},
                                    {text: data.result.PhaseList[i].BusinessOpinionList[j].FBusinessSum,style:"width:11%"},
                                    {text: data.result.PhaseList[i].BusinessOpinionList[j].FTermMonth,style:"width:11%"},
                                    {text: data.result.PhaseList[i].BusinessOpinionList[j].FRateFloat,style:"width:12%"},
                                    {text:data.result.PhaseList[i].BusinessOpinionList[j].FExecuteYearRate,style:"width:12%"},
                                    {text:data.result.PhaseList[i].BusinessOpinionList[j].FCorpusPayMethod,style:"width:11%"},
                                    {text: data.result.PhaseList[i].BusinessOpinionList[j].FVouchType,style:"width:9%"},
                                    {text: data.result.PhaseList[i].BusinessOpinionList[j].FCycleFlag,style:"width:12%"}
                                ])
                            }
                            adviceList.push({
                                PhaseName:data.result.PhaseList[i].PhaseName,
                                UserName:data.result.PhaseList[i].UserName,
                                OrgName:data.result.PhaseList[i].OrgName,
                                FTPhaseOpinion:data.result.PhaseList[i].FTPhaseOpinion,
                                BeginTime:data.result.PhaseList[i].BeginTime,
                                EndTime:data.result.PhaseList[i].EndTime,
                                Idea:data.result.PhaseList[i].Idea,
                                PhaseOpinion:data.result.PhaseList[i].PhaseOpinion,
                                BusinessOpinionList:"",
                                Color:Color,//"业务品种
                                tableHead:[{text:"客户名称",style:"width:11%"},{text:"业务品种",style:"width:11%"},{text:"金额(万元)",style:"width:11%"},{text:"期限(月)",style:"width:11%"},{text:"利率浮动值（%）",style:"width:12%"}
                                    ,{text:"执行年利率（%）",style:"width:12%"},{text:"还款方式",style:"width:11%"},{text:"主要担保方式",style:"width:9%"},{text:"是否可循环",style:"width:12%"}],
                                tableData:a
                            })
                        }

                    }
                    fox.layer.open({
                        type: 1
                        , content: "#adviceList"
                        , success: function () {
                            fox.router.to("approvalDetails",adviceList,"_advice_Div");
                        }
                    })
                } else {
                    fox.layer.open( data.result.msg );
                }
            }
        });


    };

    /*
     *取服务器时间
     * workDate 日期yyyyMMdd
     * workTime 时分秒hhmmss
     * signDate 日期yyyy-MM-dd
     * signTime 时分秒hh:mm:ss
     * */
    exports.getServiceTime=function getServiceTime(fn) {
        var _this=this;
        var  param={
            signDate: "",
            signTime: ""
        };
        fox.service.request({
            id: "signTime",
            name: "checkAttendance/checkAttendanceDemo/signTime",
            data: null,
            callback: function (code, msg, data) {
                console.log("服务器时间"+data)
                param.workDate=data.signDate.substring(0,4)+data.signDate.substring(4,6)+data.signDate.substring(6);
                param.signDate=data.signDate.substring(0,4)+"-"+data.signDate.substring(4,6)+"-"+data.signDate.substring(6);
                param.signTime=data.signTime.substring(0,2)+":"+data.signTime.substring(2,4)+":"+data.signTime.substring(4);
                param.workTime=data.signTime.substring(0,2)+data.signTime.substring(2,4)+data.signTime.substring(4);
                fn.call(this,param)
            }
        });
    };



    /*
    *根据身份证号返回 信息
    * UUserCard
    * num
    * */
    exports.getCardInfo=function getCardInfo(UUserCard, num) {

        if (num == 1) {
            //获取出生日期
            birth = UUserCard.substring(6, 10) + "-" + UUserCard.substring(10, 12) + "-" + UUserCard.substring(12, 14);
            return birth;
        }
        if (num == 2) {
            //获取性别
            if (parseInt(UUserCard.substr(16, 1)) % 2 == 1) {
                //男
                return "男";
            } else {
                //女
                return "女";
            }
        }
        if (num == 3) {
            //获取年龄
            var myDate = new Date();
            var month = myDate.getMonth() + 1;
            var day = myDate.getDate();
            var age = myDate.getFullYear() - UUserCard.substring(6, 10) - 1;
            if (UUserCard.substring(10, 12) < month || UUserCard.substring(10, 12) == month && UUserCard.substring(12, 14) <= day) {
                age++;
            }
            return age;
        }
    };

    /*
    *判断设备类型
    *
    * */
    exports.getDevicceType=function getDevicceType() {
        //获取设备类型
        var equipmentType = "";
        var u = navigator.userAgent;
        var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; //android终端
        var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
        if(isAndroid === true){
            equipmentType = "android";
        }
        if(isiOS === true){
            equipmentType = "ios";
        }
        return equipmentType;
    };


    /*
      *退出清空本地数据
      *
      * */
    exports.clearGestureData=function clearGestureData() {
        //清空所有的本地存储数据
        window.localStorage.clear();
        var equipmentType = fox.custom.getDevicceType();
        //清空ios手势
        if (equipmentType == 'ios') {
            console.log("deviceType==ios======");
            var params = "重置";//1.登录、2.重置
            var params1 = "退出";//1.退出的时候写“退出”2.s不是退出写""
            var paramDic = {appData: params, logtype: params1};
            fox.device.callGesture("md5", paramDic, function (code, message, data) {
                if (code == 0) {
                    console.log("ios==清空密码======");
                }
            });
        }
    };

    exports.back=function(){
        let flag = fox.router.remove();
        if(!flag){

            var closeFlag = fox.bus.get("closeFlag");
            if(closeFlag == undefined ){
                fox.bus.put("closeFlag","0");
                fox.layer.open({
                    content: "再按一次退出程序"
                    ,skin: 'msg'
                    ,anim:'up'
                    ,time: 1 //2秒后自动关闭
                });
                this.timer = setTimeout(() => {
                    fox.bus.remove("closeFlag");
                }, 1500);
            }else{
                fox.native.shutdown();
            }
            /*fox.layer.open({
                content: '是否退出？'
                ,btn: ['是', '否']
                ,yes: function(index){
                    fox.layer.close(index);
                    fox.native.shutdown();
                }
                ,no: function(index){
                    fox.layer.close(index);
                }
            });*/
        }
    };

    /*
   *获取年龄 精确到月份
   *
   * */
    exports.getMonthage=function getMonthage(strBirthday) {

        var returnAge;
        var strBirthdayArr = strBirthday.split("-");
        var birthYear = strBirthdayArr[0];
        var birthMonth = strBirthdayArr[1];
        var birthDay = strBirthdayArr[2];

        d = new Date();
        var nowYear = d.getFullYear();
        var nowMonth = d.getMonth() + 1;
        var nowDay = d.getDate();

        var returnMonth = "";

        if(nowYear == birthYear){
            returnAge = 0;//同年 则为0岁
            var ageDiff = nowYear - birthYear ; //年之差
            if(nowMonth == birthMonth) {
                var dayDiff = nowDay - birthDay;//日之差
                if(dayDiff < 0)
                {
                    returnAge = ageDiff - 1;
                    returnMonth = 11;
                }
                else
                {
                    returnAge = ageDiff ;
                    returnMonth = 0;
                }
            }
            else
            {
                var monthDiff = nowMonth - birthMonth;//月之差
                if(monthDiff < 0)
                {
                    returnAge = ageDiff - 1;
                    returnMonth = 12 + parseInt(monthDiff);
                }
                else
                {
                    returnAge = ageDiff ;
                    returnMonth = monthDiff;
                }
            }
        }
        else{
            var ageDiff = nowYear - birthYear ; //年之差
            if(ageDiff > 0){
                if(nowMonth == birthMonth) {
                    var dayDiff = nowDay - birthDay;//日之差
                    if(dayDiff < 0)
                    {
                        returnAge = ageDiff - 1;
                        returnMonth = 11;
                    }
                    else
                    {
                        returnAge = ageDiff ;
                        returnMonth = 0;
                    }
                }
                else
                {
                    var monthDiff = nowMonth - birthMonth;//月之差
                    if(monthDiff < 0)
                    {
                        returnAge = ageDiff - 1;
                        returnMonth = 12 + parseInt(monthDiff);
                    }
                    else
                    {
                        returnAge = ageDiff ;
                        returnMonth = monthDiff;
                    }
                }
            }
            else
            {
                returnAge = -1;//返回-1 表示出生日期输入错误 晚于今天
            }
        }

        console.log(returnAge);

        if(returnAge === 0){
            return returnMonth + '月'
        }else if(returnAge < 0){
            return returnAge;
        }
        if(returnMonth === 0){
            return returnAge + '岁'
        }else {
            return returnAge + '岁' + returnMonth + '月';
        }
    };


    /*
    *获取三个月前的时间
    *
    * */
    exports.getPastThreeMonth = function getPastThreeMonth(strBirthday) {

        var curDate = (new Date()).getTime();
        // 将半年的时间单位换算成毫秒
        var halfYear = 365 / 4 * 24 * 3600 * 1000;
        var pastResult = curDate - halfYear;  // 半年前的时间（毫秒单位）

        // 日期函数，定义起点为半年前
        var pastDate = new Date(pastResult),
            pastYear = pastDate.getFullYear(),
            pastMonth = pastDate.getMonth() + 1,
            pastDay = pastDate.getDate();

        return pastYear + '-' + pastMonth + '-' + pastDay;
    };

    /*
        *判断开始时间不能小于结束时间
        *
        * */

    exports.validTime = function validTime(startTime,endTime) {

        var arr1 = startTime.split("-");
        var arr2 = endTime.split("-");
        var date1=new Date(parseInt(arr1[0]),parseInt(arr1[1])-1,parseInt(arr1[2]),0,0,0);
        var date2=new Date(parseInt(arr2[0]),parseInt(arr2[1])-1,parseInt(arr2[2]),0,0,0);
        if(date1.getTime()>date2.getTime()) {
            return false;
        }else{
            return true;
        }
        return false;
    };

    /*
       *判断版本更新（ios）
       *
       * */

    exports.checkVersion = function checkVersion(versionFlag) {

        if(versionFlag === "2"){
            //信息框
            fox.layer.open({
                shadeClose: false,
                content: '已发布最新版本，请立即更新',
                btn: ['立即更新'],
                // yes: function(index){
                //     // fox.layer.close(index);
                //     console.log("11111");
                //     window.location.href = "https://itunes.apple.com/cn/app/id1468218805?mt=8";
                // }
                action: [
                    function(index){
                        //确定
                        console.log("==========111111111========");
                        window.location.href = "https://itunes.apple.com/cn/app/id1468218805?mt=8";
                    },
                    function(index){
                        //取消
                        console.log("==========2222222========")
                        // fox.layer.close(index);
                    }
                ]
            });
        }else if(versionFlag === "1"){
            fox.layer.open({
                content: '已发布最新版本，请立即更新',
                btn: ['取消','确定'],
                action: [
                    function(index){
                        fox.layer.close(index);
                        //取消
                        console.log("==取消===")
                    },
                    function(index){
                        fox.layer.close(index);
                        //确定
                        console.log("==确定===")
                        window.location.href = "https://itunes.apple.com/cn/app/id1468218805?mt=8";
                    }
                ]
            });
        }

    }


});
