/**
 * Created by jiangcheng on 2016/08/09.
 */
(function (window, fox) {

    //fox配置
    fox.config({
        //path配置
        paths: {
            'plugins': './libs/plugins'
        },
        // 别名配置
        alias: {
            'config': './custom/config.js'
        },
        // 不处理集合
        nature: {
            js:["https://webapi.amap.com/maps"]
        },
        // 文件编码
        charset: 'UTF-8',
        //版本号
        version:"1.0.3"

    });

    //是否启动V Console
     //let vConsole = new VConsole();

    //配置主题
    window.fox_theme="phone";

    //css依赖库
    let libs_css = [
        //------------主题相关css----------
        "./themes/"+window.fox_theme+"/css/iconfont.css",
        //-------------自定义模版-----------
        "./custom/templates/my/css/my.css",
        //-------------自定义css-----------
        "./custom/css/app.css",
    ];

    //js依赖库
    let libs_js = [
        "config",
        //-------------fox ui-------------
        "./libs/fox-ui/fox-ui-v1.0.0.js",
        //-------------fox 模版------------
        "./libs/templates/silk-v1.0.0.js",
        //-------------fox 插件------------
        "./libs/plugins/fox-plugins-v1.0.0.js",
        //-------------自定义插件-----------
        "./custom/plugins/fox.demo.js",
        "./custom/plugins/fox.touch.js",
        "./custom/plugins/fox.gesturelock.js",
        //-------------自定义模版-----------
        "./custom/templates/my/js/my.js",
        "./custom/templates/my/widget/components.js",
        //------------- app js------------
        "./custom/js/app.js",
        "./custom/plugins/aes.js",
        "./custom/js/app.version_ios.js",
        "./libs/JsBarcode.all.min.js",
    ];


    if(fox.os.ios){
        // libs_js.push("custom/plugins_ios/plugin-figureprint.js");
        // libs_js.push("custom/plugins_ios/yu.callproxy.js");
        // libs_js.push("custom/plugins_ios/yu.dCloudDevice.js");
        libs_js.push("./custom/plugins_ios/fox.callproxy.js");
        libs_js.push("./custom/plugins_ios/fox.device.js");
    };

    //路由表
    var route_tables = [
        ,'./custom/route-tables/phone/route.school.js'
    ];

    //合并lib
    var libs = libs_css.concat(libs_js, route_tables);
    fox.require.use(libs).done(function () {
        //mobile设置
        $.options.gestureConfig={
            tap: true,
            doubletap: true,
            longtap: true,
            hold: false,
            flick: true,
            swipe: true,
            drag: true,
            pinch: false
        };
        //fox别名
        window.fx = window.fox;

        //导入配置
        var config = fox.require.require("config");
        //设置配置
        fox.settings.config(config);

        //校验配置
        var verifyConfig={
            //错误处理
            error:function(errorMsg,element){
                if(element && element.componentInstance){
                    element.componentInstance.innerTip=errorMsg;
                }
            },
            //重置处理
            reset:function(element){
                if(element && element.componentInstance){
                    element.componentInstance.innerTip="";
                }
            },
            //成功处理
            success:function(element){

            },
            //装饰
            decorate:function(element,rule){
                if(element && element.componentInstance){
                    var flag=false;
                    for(var i=0;i<rule.length;i++){
                        if(fox.type(rule[i])=="object" && (rule[i]["require"] == true || rule[i]["photo_required"] == true)){
                            flag=true;
                        }else if(rule[i] === "require" || rule[i] === "photo_required"
                            || rule[i] === "photos_required"){
                            flag=true;
                        }
                    }
                    if(flag){
                        element.componentInstance.innerMarkStyle={"background-color":"#e60012"};
                    }
                }
            }

        };
        fox.valiator.addMethod("photo_required",function (value,param) {
            if(value === undefined){
                return false;
            }
            return value.image && value.image.length > 0;
        },"必输字段");
        fox.valiator.addMethod("photos_required",function (value,param) {
            if(value === undefined){
                return false;
            }
            return value.images && value.images.length > 0;
        },"必输字段");
        //安装插件
        fox.valiator.install(Vue,verifyConfig);

        //加入请求过滤器
        fox.service.addFilter({

            //过滤器名称
            name: "messageParser",
            //加密方法
            encrypt: function (word) {
                var key = CryptoJS.enc.Utf8.parse("plokIJNUHBygvCFT");
                const iv = CryptoJS.enc.Utf8.parse('qazXSWedcVFRtyui'); 
                var srcs = CryptoJS.enc.Utf8.parse(word);
                var encrypted = CryptoJS.AES.encrypt(srcs, key, {
                    iv: iv,
                    mode: CryptoJS.mode.CBC,
                    padding: CryptoJS.pad.Pkcs7
                });
                return encrypted.toString();
            },

             //解密方法
            Decrypt:function(word) {
                var key = CryptoJS.enc.Utf8.parse("plokIJNUHBygvCFT");
                const iv = CryptoJS.enc.Utf8.parse('qazXSWedcVFRtyui');         
                let decrypt = CryptoJS.AES.decrypt(word, key, { iv: iv,mode: CryptoJS.mode.CBC, padding: CryptoJS.pad.Pkcs7 });
                let decryptedStr = decrypt.toString(CryptoJS.enc.Utf8);
                return decryptedStr.toString();
            },

            //请求前触发
            before: function (event) {
                //定义请求头
                // this.encrypt(vmData.forgetSecoundPassword)
                // var tellerInfo=fox.sessionStorage.get("tellerInfo");
                var postJson = JSON.stringify(fox.sessionStorage.get("tellerInfo"));
                var tellerInfos = this.encrypt(postJson);
                //定义请求数据
                var reqData = {
                    //请求头
                    header: {tellerInfo:tellerInfos},
                    //请求数据
                    // data: event.data,
                    data: this.encrypt(JSON.stringify(event.data))

                };
                //保存导出数据
                event.code = 0;
                event.data = reqData;
                //返回处理标志，true则继续处理，false则中断处理
                return true;
            },

            //数据返回后触发
            after: function (event) {

                //只处理JSON对象
                if (fox.type(event.data) == "object" && fox.type(event.data.header)!="undefined") {
                    //获取响应头
                    var rspHeader = event.data.header;
                    //获取响应数据
                    // var rspData = event.data.data;

                    // var rspHeader = JSON.parse(this.Decrypt(event.data.header));
                    var rspData = JSON.parse(this.Decrypt(event.data.data));

                    if (fox.type(rspHeader.code) == "undefined" || rspHeader.code == 0) {
                        //保存导出数据
                        event.code = 0;
                        event.message = "";
                        event.data = rspData;
                        //返回处理标志，true则继续处理，false则中断处理
                        return true;
                    } else {
                        //保存导出数据
                        event.code = rspHeader.code;
                        event.message = rspHeader.msg;
                        event.data = rspData;
                        //返回处理标志，true则继续处理，false则中断处理
                        return true;
                    }
                }

                //返回处理标志，true则继续处理，false则中断处理
                return true;
            },

            //异常发生后触发
            exception: function (event) {
                //获取url
                var url = window.location.toString();
                if ("unlogin" == event.message) {
                    // //修改默认root div
                    // router.setDefaultRootId("_rootDiv");
                    // var index = url.indexOf("#!");
                    // if (index != -1) {
                    //     url = url.substring(0, index);
                    // }
                    // url += "#!login";
                    // var data = new Date();
                    // url += "?time=";
                    // url += data.getTime();
                    // window.location = url;

                    //询问框
                    fox.layer.open({
                        content: '请重新登录'
                        ,shadeClose:false
                        ,btn: ['确定']
                        ,yes: function(index){
                            //location.reload();
                            //注销全局websocket
                            fox.service.unRegisterMessageService("school_login");

                            fox.sessionStorage.clear();
                            fox.router.to("school_login");

                            fox.layer.close(index);
                        }
                    });


                    //返回处理标志，true则继续处理，false则中断处理
                    return false;
                }
                if ("unexist" == event.message) {
                    //询问框
                    fox.layer.open({
                        content: '该用户不存在或已注销，请重新注册'
                        ,shadeClose:false
                        ,btn: ['确定']
                        ,yes: function(index){
                            fox.service.unRegisterMessageService("school_login");

                            fox.sessionStorage.clear();
                            fox.router.to("school_login");

                            fox.layer.close(index);
                        }
                    });
                    return false;
                }
                if ("blacklist" == event.message) {
                    //询问框
                    fox.layer.open({
                        content: '您因访问次数严重超限，暂时限制使用健康洛阳'
                        ,shadeClose:false
                        ,btn: ['确定']
                        ,yes: function(index){
                            fox.service.unRegisterMessageService("school_login");

                            fox.sessionStorage.clear();
                            fox.router.to("school_login");

                            fox.layer.close(index);
                        }
                    });
                    return false;
                }
                //重复提交处理
                if ("resubmit" == event.message) {
                    fox.logger.error("resubmit error");
                    //返回处理标志，true则继续处理，false则中断处理
                    return false;
                }

                if ("stop_system" == event.message) {
                    //询问框
                    fox.layer.open({
                        content: '系统维护中......'
                        ,shadeClose:false
                        ,btn: ['确定']
                        ,yes: function(index){
                            fox.layer.close(index);
                        }
                    });
                    return false;
                }

                if ("unWhite" == event.message) {
                    //询问框
                    fox.layer.open({
                        content: '系统正在开放中，敬请期待'
                        ,shadeClose:false
                        ,btn: ['确定']
                        ,yes: function(index){
                            fox.layer.close(index);
                        }
                    });
                    return false;
                }



                //返回处理标志，true则继续处理，false则中断处理
                return true;
            }
        });
        //设置默认添加历史记录 push生成记录put不生成记录
 //       fox.router.setDefaultOpsType(fox.core.OperationType.Push);
        //设置默认root id
        fox.router.setDefaultRootId(config.defaultRootId);
        //加入路由过滤器
        fox.router.addFilter({

            /**
             * 过滤器名称
             */
            name: "default",

            /**
             * 路由跳转前执行
             * @param code
             * @param cite
             */
            before:function(code, cite){

                // if(code == "frame"||code == "first") {
                //     return true;
                // }
                //
                // var tellerInfo =  fox.sessionStorage.get("tellerInfo");
                // if(tellerInfo)
                //     return true;
                // else{
                //     fox.layer.open("请先登录");
                //     return false;
                // }
                return true;

            },

            /**
             * 加载路由内容前执行
             * @param code
             * @param cite
             */
            mount:function(code,cite){

            },

            /**
             * ready函数执行
             * @param exports
             * @param code
             * @param data
             * @param cite
             */
            ready: function (exports, code, data, cite) {

            },

            /**
             * 卸载路由内容前执行
             * @param code
             * @param cite
             */
            unMount:function(code,cite){

            },

            /**
             * destroy函数执行
             * @param exports
             * @param code
             * @param cite
             */
            destroy: function (exports, code, cite) {

            }

        });

        //创建hash处理事件
        var hashFn=function(defaultHash){

            var sIndex = location.hash.indexOf("!");
            var eIndex = location.hash.indexOf("?");

            if (sIndex != -1) {
                //定义hash
                var hash = "";
                //定义data
                var data = {};

                if (eIndex == -1) {
                    //获取hash
                    hash = location.hash.slice(sIndex + 1);
                } else {
                    //获取hash
                    hash = location.hash.substring(sIndex + 1, eIndex);
                    var queryStr = location.hash.slice(eIndex + 1);
                    var items = queryStr.split("&");
                    //解析数据
                    for (var i = 0; i < items.length; i++) {
                        var ss = items[i].split("=");
                        data[ss[0]] = ss[1];
                    }
                }
                fox.logger.info("触发hash事件,hash:" + hash);
                //路由跳转
               // fox.router.replace(hash, data);
                 fox.router.to(hash, data);

            }else if(defaultHash){
                //路由跳转
          //      fox.router.replace(defaultHash);
                 fox.router.to(defaultHash);
            }

        };
        var login = function(longitude,latitude){
            console.log("=========version=====" + my_version.versionIos)
            var sessionid = fox.localStorage.get("sessionid");
            var equipmentType = fox.custom.getDevicceType();
            if(sessionid){
                console.log("sessionid==存在======");
                //验证sessionid  持久化登录
                fox.service.request({
                    id:"noLogin",
                    name:"customer/customer/noLogin",
                    data:{
                        sessionid:sessionid,
                        version:my_version.versionIos,
                        equipmentType:equipmentType,
                        longitude:longitude,
                        latitude:latitude
                    },
                    callback:function(code, message, data){
                        if (code == 0 || code == undefined) {
                            fox.localStorage.put("firstLogin","1");
                            // data=JSON.stringify(data);
                            if (data.code == "0") {
                                fox.sessionStorage.put("checkPidInfo", "");
                                console.log("sessionid==验证成功======");
                                config.startPage = "school_frame";
                                console.log("school_frame========");
                                fox.localStorage.remove("sessionid" );
                                if(data.hospitalinfo.distance< 1000){
                                    data.hospitalinfo.distance = data.hospitalinfo.distance +"米"
                                }else if(data.hospitalinfo.distance >= 1000){
                                    /*var d = ((data.hospitalinfo.distance)/1000+"").split(".");
                                    data.hospitalinfo.distance = d[0]+"公里";*/
                                    data.hospitalinfo.distance = ((data.hospitalinfo.distance)/1000).toFixed(1)+"公里";
                                }
                                fox.bus.put("pid",data.userInfo.pid);
                                fox.localStorage.put("sessionid",data.userInfo.sessionid);
                                fox.bus.put("loginUserInfo",data.userInfo);
                                fox.bus.put("loginPhoneNum",data.userInfo.user_phone);
                                data.hospitalinfo.indexHospitalName =  data.hospitalinfo.hospital_name;
                                fox.bus.put("HomehospitalData", data.hospitalinfo);

                                var equipmentType = fox.custom.getDevicceType();
                                fox.bus.put("loginDeviceType",equipmentType);
                                fox.sessionStorage.put("indexHospitalId", data.hospitalinfo.hospital_id);
                                fox.sessionStorage.put("indexInterfaceType", data.hospitalinfo.interface_type);
                                fox.bus.put("indexHospitalName",  data.hospitalinfo.hospital_name);
                                fox.sessionStorage.put("tellerInfo", {
                                    sessionid: data.userInfo.sessionid,
                                    card_name: data.userInfo.card_name,
                                    card_number: data.userInfo.card_number,
                                    cardNumber: data.userInfo.cardNumber,
                                    is_realname:data.userInfo.is_realname,
                                    user_id:data.userInfo.user_id,
                                    hospital_id: data.hospitalinfo.hospital_id,
                                    interface_type:data.hospitalinfo.interface_type,
                                    user_phone:data.userInfo.user_phone,
                                    chnlcode: "001",
                                    equipmentType:equipmentType,
                                });
                                fox.sessionStorage.put("switchMap", {
                                    switchFlag: data.switchMap.switchFlag,
                                    switchDesc: data.switchMap.switchDesc
                                });

                                var zxwzFlag = data.isWhite;
                                fox.sessionStorage.put("zxwzFlag", zxwzFlag);
                                var versionFlag = data.versionFlag;
                                //判断设备类型
                                if(equipmentType == 'ios'){
                                    if(zxwzFlag == "0"){
                                        var paramLogin = {
                                            "userId": data.userInfo.user_id,
                                            "name": data.userInfo.card_name,
                                            "userSig": data.userSig,
                                            "actionType": 1
                                        };
                                        fox.device.callTRTC("callTRTC", paramLogin, function (code, message, data) {
                                            console.log("苹果登录腾讯云成功："+code);
                                        });
                                    }
                                    var params = "登录";//1.登录、2.重置
                                    var params1 = "";//1.退出的时候写“退出”2.s不是退出写""
                                    var paramDic={appData:params,logtype:params1};
                                    fox.device.callGesture("md5",paramDic,function(code,message,data){
                                        if (code == 0) {
                                            console.log("ios=======成功=");
                                            console.log("versionFlag=======成功=" + versionFlag);
                                            if(message === '忘记密码'){

                                                //点击切换登录方式
                                                config.startPage = "school_login";
                                                //页面跳转
                                                hashFn(config.startPage);
                                                fox.custom.clearGestureData(); fox.sessionStorage.put("tellerInfo", {
                                                    sessionid: "",
                                                    card_name: "",
                                                    card_number: "",
                                                    is_realname: "",
                                                    user_id: "",
                                                    hospital_id: "",
                                                    interface_type: "",
                                                    pid:""
                                                });
                                                //校验版本
                                                fox.custom.checkVersion(versionFlag);
                                            }else{
                                                hashFn(config.startPage);
                                                //校验版本
                                                fox.custom.checkVersion(versionFlag);

                                            }
                                        }
                                    });
                                }else{
                                    console.log("deviceType=======android=");
                                    if(zxwzFlag == "0"){
                                        var params = {};
                                        params.timId=data.userInfo.user_id;
                                        params.timSig=data.userSig;
                                        fox.native.call("timLogin", params, function (code, message, data) {
                                            console.log("安卓登录腾讯云成功"+code);
                                        });
                                    }
                                    //手势登录
                                    var oldPwd = fox.localStorage.get("gesture_pwd");
                                    //判断手势登录是否存在
                                    if(oldPwd){
                                        // console.log("oldPwd========" + oldPwd);
                                        fox.gestureLock.verifyPwd(oldPwd, function(code, data) {
                                            if (code == 0) {
                                                if(data.status == '1'){
                                                    //验证手势成功
                                                    hashFn(config.startPage);
                                                }else if(data.status == '2'){
                                                    //点击切换登录方式
                                                    config.startPage = "school_login"
                                                    //页面跳转
                                                    hashFn(config.startPage);
                                                }
                                                console.log("手势验证成功========");
                                            } else {
                                                //页面跳转
                                                hashFn(config.startPage);
                                                console.log("手势验证失败========");
                                            }
                                        });
                                    }else{
                                        //页面跳转
                                        hashFn(config.startPage);
                                    }
                                }

                            } else {
                                console.log("sessionid==失败======");
                                console.log("sessionid==失败======" + config.startPage);
                                //页面跳转
                                hashFn(config.startPage);
                            }
                        } else {
                            console.log("请求==失败======");
                            console.log("请求==失败======" + config.startPage);

                            //清空手势登录
                            fox.custom.clearGestureData();
                            //页面跳转
                            hashFn(config.startPage);
                        }
                    }
                });
            }else{
                console.log("sessionid==不存在======");
                //页面跳转
                hashFn(config.startPage);
            }
        };
        //定位
        var firstLogin = fox.localStorage.get("firstLogin");
        if(firstLogin == "1"){
            var equipmentType = fox.custom.getDevicceType();
            if(equipmentType === "android"){
                fox.native.call("getLocation",{},function(a,b,c){
                    console.log("a:"+a+"b:"+b+"c:"+c);
                    if(0 == a){
                        var obj = JSON.parse(c);
                        fox.sessionStorage.put("longitude", obj.longitude);
                        fox.sessionStorage.put("latitude", obj.latitude);
                        login(obj.longitude,obj.latitude);
                    }else{
                        console.log("失败"+a,b,c)
                        fox.sessionStorage.put("longitude","");
                        fox.sessionStorage.put("latitude", "");
                        login("","");
                    }

                });
            }else if(equipmentType === "ios"){
                //login("","");
                fox.device.callLocation("callLocation", {}, function (code, message, data) {
                    console.log("code:"+code+"message:"+message+"data:"+data);
                    if (code == 0) {
                        var callBackParams = fox.base64.decode(data);
                        var obj = JSON.parse(callBackParams);
                        fox.sessionStorage.put("longitude", obj.longitude);
                        fox.sessionStorage.put("latitude", obj.latitude);
                        login(obj.longitude,obj.latitude);
                    } else {
                        fox.sessionStorage.put("","");
                        fox.sessionStorage.put("", "");
                        login("","");
                    }
                });
            }
        }else{
            //this.test();
            //this.showAgView();
            //fox.localStorage.put("firstLogin","1");
            hashFn(config.startPage);
        }
        //关闭splash
        fox.splash.close();

        //触发plusready 方法
        fox.$.trigger(document,"plusready");

    })

}(window, fox));
