/**
 * Created by 江成
 */
(function (fox, window, factory) {
    // 判断是否支持模块定义
    let hasDefine = (typeof define === 'function');
    if (hasDefine) {
        //获取对象
        let exports = factory(fox,window);
        //定义模块
        define(exports);
        //安装插件(兼容非模块的访问方式)
        window.fox.demo = exports;

    } else {
        //获取对象
        let exports = factory(fox,window);
        //安装插件
        window.fox.demo = exports;
    }

}(fox, window, function (fox,window) {

    //定义Demo对象
    let demo={

        /**
         * 同步测试
         * @param message
         */
        syncFn:function(message) {
            //参数
            let args = {
                service: "demoPlugin", //对应FXProxy注册在配置文件上的服务名
                action: "syncFn", //对应FXProxy中标志了@JavascriptInterface的方法
                data: [message],  //对应方法中的参数
                async: false      //是否异步
            };
            return window.fxBridge.exec(args);
        },

        /**
         * 异步测试
         * @param message
         * @param callback
         */
        asyncFn:function(message,callback) {
            //参数
            let args = {
                service: "demoPlugin",//对应FXProxy注册在配置文件上的服务名
                action: "asyncFn",//对应FXProxy中标志了@JavascriptInterface的方法
                data: [message],  //对应方法中的参数
                async: true,      //是否异步
                callback:callback //异步回调函数
            };
            return window.fxBridge.exec(args);
        }

    };
    return demo;

}));
