/**
 * Created by 江成
 */
(function(fox, window, factory) {
	// 判断是否支持模块定义
	let hasDefine = (typeof define === 'function');
	if (hasDefine) {
		//获取对象
		let exports = factory(fox, window);
		//定义模块
		define(exports);
		//安装插件(兼容非模块的访问方式)
		window.fox.gestureLock = exports;

	} else {
		//获取对象
		let exports = factory(fox, window);
		//安装插件
		window.fox.gestureLock = exports;
	}

}(fox, window, function(fox, window) {

	//定义Demo对象
	let gestureLock = {
		/**
		 * 设置 手势密码
		 * @param message
		 * @param callback
		 */
		setPwd: function(callback) {
			//参数
			let args = {
				service: "gesPlugin", //对应FXProxy注册在配置文件上的服务名
				action: "setPwd", //对应FXProxy中标志了@JavascriptInterface的方法
				data: [], //对应方法中的参数
				async: true, //是否异步
				callback: callback //异步回调函数
			};
			return window.fxBridge.exec(args);
		},
		/**
		 * 验证 手势密码
		 * @param message
		 * @param callback
		 */
		verifyPwd: function(oldPwd, callback) {
			//参数
			let args = {
				service: "gesPlugin", //对应FXProxy注册在配置文件上的服务名
				action: "verifyPwd", //对应FXProxy中标志了@JavascriptInterface的方法
				data: [oldPwd], //对应方法中的参数
				async: true, //是否异步
				callback: callback //异步回调函数
			};
			return window.fxBridge.exec(args);
		},
		/**
		 * 修改 手势密码
		 * @param message
		 * @param callback
		 */
		changePwd: function(oldPwd, callback) {
			//参数
			let args = {
				service: "gesPlugin", //对应FXProxy注册在配置文件上的服务名
				action: "changePwd", //对应FXProxy中标志了@JavascriptInterface的方法
				data: [oldPwd], //对应方法中的参数
				async: true, //是否异步
				callback: callback //异步回调函数
			};
			return window.fxBridge.exec(args);
		}

	};
	return gestureLock;

}));
