/**
 * Created by jiangcheng on 2016/10/14.
 */
(function (fox, window, factory) {
    // 判断是否支持模块定义
    var hasDefine = (typeof define === 'function');
    if (hasDefine) {
        //获取对象
        var exports = factory(fox);
        //定义模块
        define(exports);
        //安装插件(兼容非模块的访问方式)
        window.fox.callproxy = exports;

    } else {
        //获取对象
        var exports = factory(fox);
        //安装插件
        window.fox.callproxy = exports;
    }

}(fox, window, function (fox) {
    //定义callback对象
    var callproxy = {

        /**
         * 当前索引
         */
        _index: 0,

        /**
         * 最大索引
         */
        _maxIndex: 500,

        /**
         * 生成索引
         * @private
         */
        _generateIndex: function () {
            var index = ++this._index;
            if (this._index >= this._maxIndex) {
                this._index = 0;
            }
            return String(index);
        },

        /**
         * 注册全局回调函数
         *
         * @param func
         * @param endFunc
         */
        register: function (func,endFunc) {
            //初始化空间
            if(fox._sys_callback==undefined){
                fox._sys_callback={}
            }
            //获取索引
            var i = callproxy._generateIndex();

            if(endFunc) {
                //保存函数
                fox._sys_callback[i] = function (code, message, data) {
                    //调用函数
                    func(code, message, data);

                    if (endFunc(code, message, data) === true) {
                        //移除函数
                        delete fox._sys_callback[i];
                    }

                }
            }else{
                //保存函数
                fox._sys_callback[i] = function (code, message, data) {
                    //移除函数
                    delete fox._sys_callback[i];
                    //调用函数
                    func(code, message, data);
                }
            }
            //生产方法
            var s = "window.fox._sys_callback['" + i + "']";
            return s;
        }
    };
    //返回callback对象
    return callproxy;
}));
