/**
 * Created by jiangcheng on 2016/08/28.
 */
(function (window, factory) {
    // 判断是否支持模块定义
    var hasDefine = (typeof define === 'function');
    if (hasDefine) {
        //获取对象
        var exports = factory(fox, fox.callproxy);
        //定义模块
        define(exports);
        //安装插件(兼容非模块的访问方式)
        window.fox.dClouddevice = exports;

    } else {
        //获取对象
        var exports = factory(fox, fox.callproxy);
        //安装插件
        window.fox.dClouddevice = exports;
    }
    //初始化 dCloud需要的全局对象
    if(!window.plus){
         window.plus = {};
    }
    window.plus.bridge = window.fox.dClouddevice;

} (window, function (fox, callproxy) {



    //外设访问器
    var device = {

        //计数
        _count:0,

        /**
         * 显示cover
         * @private
         */
        _showCover:function _showCover() {
            //计算重复调用次数
            this._count += 1;
            //只有count为1，才允许绘制界面
            if (this._count > 1) {
                return;
            }
            //打开cover
            this.coverId=fox.layer.open({
                type: fox.layer.Cover
                ,content: '外设读取中...',
                shadeClose:false
            });
        },

        /**
         * 隐藏cover
         * @private
         */
        _hideCover:function _hideCover() {
            //计算重复调用次数
            this._count -= 1;
            //只有count为0，才允许关闭界面
            if (this._count > 0) {
                return;
            }
            //隐藏
            fox.layer.close(this.coverId);
        },


        /*
        * Dcloud 对外调用接口(异步)
        *
        *
        *
        * */
        exec:function(type,action,paramsWithMethod){
            if(fox.type(paramsWithMethod)!="array"){
                return;
            }
            var callback = paramsWithMethod[0];
            paramsWithMethod.shift();
            this.call(type,action,paramsWithMethod,callback);
        },
        /*
         * Dcloud 对外调用接口(同步步)
         *
         *
         *
         * */



        callbackId:function(success, fail){

            var callBackMethod = function(code,message,data){


                //序列化为json，这个和foxshell不同
                if(data){
                    data = JSON.parse(data);
                }
                if(code == 0){ //正确
                    success(data);
                }
                else {
                     fail(data);
                }
            }

            var callbackName = callproxy.register(callBackMethod, function () {
                return false;//返回false表示调用一次方法之后，此方法不销毁
            });
            return callbackName;
        },




        /**
         * 调用外设
         * @param type
         * @param action
         * @param params
         * @param callbackName 方法全局名称
         */
        call: function (type, action, params, callbackName) {

            //设置默认值
            if (params == undefined) {
                params = {};
            }


            var reqData;
            //请求数据转换为字符串
            if (fox.type(params) == "object") {
                reqData = JSON.stringify(params);
            } else if(fox.type(params)=="array"){
                reqData={data:params};
                reqData = JSON.stringify(reqData);
            } else {
                reqData = params;
            }

            try {
            //调用外设
                _FOX_PROXY_DCLOUD_DEVICE.call(type, action, reqData, callbackName);
            }catch(ex){
                //打印日志
                fox.logger.error(ex.message,ex);
            }
        },

        /**
         * 获取外设配置
         * @param callback
         */
        getDeviceConfig: function (callback) {


            //生成回调方法
            var callbackName = "";
            if (callback) {
                callbackName = callproxy.register(callback);
            }
            //获取外设配置
            _FOX_PROXY_DEVICE.getDeviceConfig(callbackName);
        },

        /**
         * 获取外设映射
         * @param callback
         */
        getDeviceMap: function (callback) {

            //生成回调方法
            var callbackName = "";
            if (callback) {
                callbackName = callproxy.register(callback);
            }
            //获取外设配置
            _FOX_PROXY_DEVICE.getDeviceMap(callbackName);
        },

        /**
         * 设置外设映射
         * @param data
         * @param callback
         */
        setDeviceMap: function (data, callback) {
            //设置默认值
            if (data == undefined) {
                data = {};
            }

            var reqData;
            //请求数据转换为字符串
            if (fox.type(data) == "object") {
                reqData = JSON.stringify(data);
            } else {
                reqData = data;
            }

            //生成回调方法
            var callbackName = "";
            if (callback) {
                callbackName = callproxy.register(callback);
            }
            //获取外设配置
            _FOX_PROXY_DEVICE.setDeviceMap(reqData, callbackName);
        },

        /**
         * 调用摄像头
         * @param cameraType
         * @param callback
         * @param params
         */
        callCamera: function (cameraType,callback, params) {
            this.call("camera", cameraType, params, callback);
        },

        /**
         * 调用签名
         * @param action
         * @param callback
         * @param params
         */
        callSign: function (callback, params) {
            this.call("sign", "sign", params, callback);
        },

        /**
         * 调用密码键盘
         * @param action
         * @param callback
         * @param params
         */
        callPin: function (action, callback, params) {
            this.call("pin", action, params, callback);
        },






    };
    //返回对象
    return device;

}) );
