define(function (require, exports) {

    //page加载完成后调用ready方法
    exports.ready = function (code, data, cite) {
        //vue data
        var vmData={
            //预约时间的数组
            appointmentDate: [],
            table_header: [{text: "", style: "text-align:left;width:25%;height:8px", columnStyle: "width:25%;"},
                {text: "", style: "text-align:left;width:75%;height:8px", columnStyle: "width:75%;"}],
            doctorList: [],
            departmentList:[{department:"全部"}],
            departmentTypeList:[],
            activeClass:0,
            hospital_name:data.hospital_name,
            hospital_id:data.hospital_id,
            activeClass_left:0,
            nucleicTest:data
        }

        //创建vue model
        let vm=new Vue({
            el:cite.el,
            //数据
            data:vmData,
            // computed:{
            //     active:function () {
            //         return {
            //             departmentList:[{department:"神经内科"},{department:"心血管内科"},{department:"呼吸内科"},{department:"消化内科"}],
            //             ind:''
            //         }
            //     }
            //
            // },

            //方法
            methods:{
                //日期选择
                selectDate: function (index) {
                    let that = this;
                    vmData.Day = vmData.appointmentDate[index].myDate;
                    that.getDepartment(vmData.Day);
                    vmData.activeClass = index;

                },
                //动态切换选中颜色样式
                selectDepartment: function (index) {
                    this.activeClass_left = index;
                },
                //选择科室
                selectDepartmentType: function (index) {
                    var mydata = {
                        hospital_name:vmData.hospital_name,
                        hospital_id:vmData.hospital_id
                    }
                    fox.bus.put("hospitalData",mydata);
                    var departmentData ={
                        DeptId: vmData.departmentTypeList[index].DeptId,
                        DeptName:vmData.departmentTypeList[index].DeptName,
                        index:vmData.activeClass,
                        nucleicTest:vmData.nucleicTest
                    };
                    fox.router.append("appointmentRegistration",departmentData);
                },
                getDepartment:function (Day) {
                    var myDate = vmData.appointmentDate[0].myDate;
                    fox.service.request({
                        id: "queryDepartment",
                        name: "service/theDayRegistered/queryDepartment",
                        data: {
                            RegType:"2",
                            RigsterType:"",
                            hospital_id:vmData.hospital_id,
                            Day: Day !== undefined ? Day : myDate,
                            nucleicTest:vmData.nucleicTest
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000" ||data.code==undefined) {
                                   	vmData.departmentTypeList = data.result;
					fox.layer.open(data.msg);
                                } else {
                                    vmData.departmentTypeList = data.result;
                                }
                            } else {
                                fox.layer.open("网络异常");
                            }
                        }
                    });
                },
                getmyDate: function () {
                    var now = new Date();
                    var nowTime = now.getTime();
                    var oneDayTime = 24 * 60 * 60 * 1000;
                    var list = [];

                    for (var i = 0; i < 60; i++) {
                        //显示周一
                        var ShowTime = nowTime + (i + 1) * oneDayTime;
                        //初始化日期时间
                        var myDate = new Date(ShowTime);
                        var year = myDate.getFullYear();
                        var month = myDate.getMonth() + 1;
                        var date = myDate.getDate();
                        if (month < 10) {
                            month = "0" + month;
                        }
                        if (date < 10) {
                            date = "0" + date;
                        }
                        // console.log(year+"-"+month+"-"+date);
                        var date = year + "-" + month + "-" + date;
                        var week = "周" + "日一二三四五六".charAt(myDate.getDay());
                        // console.log(week);
                        var makeTime = {
                            myDate: date,
                            date: date.substring(5, 10),
                            week: week
                        }
                        list.push(makeTime);
                    }
                    setTimeout(function () {
                        var appointmentMakeSwiper = new Swiper('#appointmentMakeSwiper',{
                            spaceBetween: 0,
                            slidesPerView : 5,
                        });
                    },300)
                    vmData.appointmentDate = list;
                    this.getDepartment();
                },
                //回退
                back: function () {
                    fox.router.remove();
                },
                //调整page size
                adjustPageSize: function () {
                    //屏幕当前的高度
                    var oHeight = $.getClientHeight();
                    //设置page 高度
                    $(".fox-page > .fox-content").css("height", oHeight + "px");
                }
            },
            //加载后处理
            mounted:function(){
                this.adjustPageSize();
                this.getmyDate();
                // fox.localStorage.remove("_global_loginInfo");
                $('.fox-switch').switch();

                $(this.$refs.phoneSwitch).on('toggle',(event)=>{
                    this.remPhone = event.detail.isActive
                });

                $(this.$refs.userSwitch).on('toggle',(event)=>{
                    this.remUser = event.detail.isActive
                });

            }
        });
    };

    //消息处理
    exports.onmessage = function (type, message, cite) {

    };

    //page销毁时触发destroy方法
    exports.destroy = function (id, cite) {

    }
});
