/**
 * Created by jiangcheng on 2018/03/06.
 */
define(function (require, exports) {

    //page加载完成后调用ready方法
    exports.ready = function (code, data, cite) {
        var hospitalData = fox.bus.get("hospitalData");
        let vmData = {
            //预约时间的数组
            appointmentDate: [],
            table_header: [{text: "", style: "text-align:left;width:25%;height:8px", columnStyle: "width:25%;"},
                {text: "", style: "text-align:left;width:75%;height:8px", columnStyle: "width:75%;"}],
            doctorList: [],
            DeptName: data.DeptName,//科室名称
            DeptId: data.DeptId,//科室ID
            Day: new Date().format("yyyy-MM-dd"),
            hospital_name: data.hospital_name,
            hospital_id: data.hospital_id,
            activeClass:data.index,
            LockPass:"",
            RegisteredDate:[],
            nucleicTest:data.nucleicTest,

        }


        //创建vue model
        let vm = new Vue({
            el: "#appointmentRegistration",
            //数据
            data: vmData,
            // 计算属性的 getter
            myPrice: function () {
                // `this` 指向 vm 实例
                var price = vmData.Price;
                return this.myPrice = parseFloat(price).toFixed(2);
            },
            //方法
            methods: {
                back: function () {
                    console.log("返回");
                    // history.back(-1);
                    fox.router.remove();
                },
                //日期选择
                selectDate: function (index) {
                    let that = this;
                    vmData.Day = vmData.appointmentDate[index].myDate;
                    that.getDoctor(vmData.Day);

                },
                //查看挂号医生详情
                lookDoctor: function (index) {
                    let that = this;
                    var IsTime =  vmData.doctorList[index].IsTime;
                    if (IsTime ==  "1") {
                        var mydata = {
                            AsRowid:  vmData.doctorList[index].AsRowid,
                            VisitID: vmData.doctorList[index].VisitID,
                            LockPass: vmData.LockPass,
                        }
                        that.queryDoctorDate(mydata,index);
                    } else {
                        that.appendData(index);
                    }
                    // var mydata = {
                    //     hospital_name: vmData.hospital_name,
                    //     hospital_id: vmData.hospital_name
                    // }
                    // fox.bus.put("hospitalData", mydata);
                    // var doctorDetail = vmData.doctorList[index];
                    // var key = "Day";
                    // var value = vmData.doctorList[index].BegTime.substring(0,10);
                    // doctorDetail[key] = value;
                    // fox.router.append("appointmentDetails", doctorDetail);
                },
                //跳转信息绑定
                appendData: function (index) {
                    var List = [];
                    this.List=JSON.parse(JSON.stringify(vmData.doctorList));
                    var Registered_Data = vmData.RegisteredDate;
                    // Registered_Data.nucleicTest = vmData.nucleicTest;

                    if (vmData.RegisteredDate.length > 0) {
                        for (let i in vmData.RegisteredDate) {
                            // vmData.RegisteredDate[i].concat=vmData.doctorList[index];
                            for (let key in vmData.doctorList[index]) {
                                vmData.doctorList[index].Price = vmData.RegisteredDate[i].Price;
                                vmData.doctorList[index].HBTime = vmData.RegisteredDate[i].TimeValue;
                                vmData.doctorList[index].RegCount = vmData.RegisteredDate[i].RegCount;
                                Registered_Data[i][key] = vmData.doctorList[index][key];
                            }
                        }
                    } else {
                        vmData.doctorList[index].Price = parseFloat(vmData.doctorList[index].Price).toFixed(2);
                        Registered_Data = vmData.RegisteredDate.concat(vmData.doctorList[index]);
                        Registered_Data[0].nucleicTest = vmData.nucleicTest;
                    }
                    vmData.doctorList = this.List;
                    fox.router.append("appointmentDetails", Registered_Data);
                },
                //获取挂号医生
                getDoctor: function (Day) {
                    var myDate = vmData.appointmentDate[vmData.activeClass].myDate;
                    fox.service.request({
                        id: "queryDoctor",
                        name: "service/theDayRegistered/queryDoctor",
                        data: {
                            RegType: "2",
                            Day: Day !== undefined ? Day : myDate,
                            DeptId: vmData.DeptId,
                            nucleicTest:vmData.nucleicTest
                            // idBack:vm.idBack.image,
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000" ||data.code==undefined) {
                                    fox.layer.open(data.msg);
                                    vmData.doctorList = "";
                                } else {
                                    vmData.LockPass = data.LockPass;
                                    fox.bus.put("LockPass",vmData.LockPass);//锁号密钥
                                    for (let i in data.result) {
                                        var price = data.result[i].Price;
                                        data.result[i].Price = parseFloat(price).toFixed(2);
                                        data.result[i].BegTime = data.result[i].BegTime.substring(0, 10);
                                        data.result[i].EnSerNumList = data.result[i].EnSerNumList;
                                    }
                                    vmData.doctorList = data.result;
                                }
                            } else {
                                fox.layer.open("网络异常");
                            }
                        }
                    });
                },
                queryDoctorDate: function (mydata,index) {
                    let that = this;
                    fox.service.request({
                        id: "queryDoctorDate",
                        name: "service/theDayRegistered/queryDoctorDate",
                        data: {
                            RegType: "2",
                            AsRowid: mydata.AsRowid,
                            VisitID: mydata.VisitID,
                            Day: vmData.Day,
                            LockPass:mydata.LockPass,
                            // idBack:vm.idBack.image,
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000") {
                                    fox.layer.open(data.msg);
                                    that.back();
                                } else {
                                    // for (let i in data.result.List) {
                                    //     data.result[i].BegTime = data.data.result.List[i].BegTime.substring(0,10);
                                    // }
                                    vmData.RegisteredDate = data.result.List;
                                    that.appendData(index);
                                }
                            } else {
                                fox.layer.open("网络异常");
                            }
                        }
                    });
                },
                getmyDate: function () {
                    let _this = this;
                    var now = new Date();
                    var nowTime = now.getTime();
                    var oneDayTime = 24 * 60 * 60 * 1000;
                    var list = [];

                    for (var i = 0; i < 60; i++) {
                        //显示周一
                        var ShowTime = nowTime + (i + 1) * oneDayTime;
                        //初始化日期时间
                        var myDate = new Date(ShowTime);
                        var year = myDate.getFullYear();
                        var month = myDate.getMonth() + 1;
                        var date = myDate.getDate();
                        if (month < 10) {
                            month = "0" + month;
                        }
                        if (date < 10) {
                            date = "0" + date;
                        }
                        // console.log(year+"-"+month+"-"+date);
                        var date = year + "-" + month + "-" + date;
                        var week = "周" + "日一二三四五六".charAt(myDate.getDay());
                        // console.log(week);
                        var makeTime = {
                            myDate: date,
                            date: date.substring(5, 10),
                            week: week
                        }
                        list.push(makeTime);
                    }
                    vmData.appointmentDate = list;
                    setTimeout(function () {
                        var appointmentRegistrationSwiper1 = new Swiper('#appointmentRegistrationSwiper1',{
                            spaceBetween: 0,
                            slidesPerView : 5,
                        });
                        appointmentRegistrationSwiper1.slideTo(vmData.activeClass, 1000, false);//切换到第一个slide，速度为1秒

                    },300)
                    _this.getDoctor();
                },

                //路由跳转
                to: function (id) {
                    fox.router.append(id);
                },

            },
            //加载后处理
            mounted: function () {
                var tellerInfo = fox.sessionStorage.get("tellerInfo");
                var hid = tellerInfo.hospital_id;
                if("lysfybjy0002" == hid && vmData.DeptName.indexOf("发热")!=-1)
                {
                    fox.layer.open("请按预约就诊时间提前1-2小时到发热门诊进行核酸检测，结果出具前需在发热门诊\n留观，留观期间正常就诊。");

                }
                this.getmyDate();

            },
            //销毁前
            beforeDestroy: function () {

            }
        });


    };

    //消息处理
    exports.onmessage = function (type, message, cite) {

    };

    //page销毁时触发destroy方法
    exports.destroy = function (id, cite) {

    }
});


