define(function (require, exports) {
var clear_time;
    //page加载完成后调用ready方法
    exports.ready = function (code, data, cite) {
        //vue data
        let vmData={
            m_verify_tip:"获取验证码",
            m_count:60,
            m_disabled:false,
            m_intervalId:undefined,
            forgetPhoneNum:"",
            msgAuthCode:"",
            autBtnClick:true
        }
        //创建vue model
        var vm=new Vue({
            el:cite.el,
            data:vmData,
            //方法
            methods:{
                //路由跳转
                to:function(id){

                    if(!(/^1[1-9]\d{9}$/.test(vmData.forgetPhoneNum))){
                        fox.layer.open({
                            content: '请输入正确的手机号码'
                            ,skin: 'msg'
                            ,anim:'up'
                            ,time: 2 //2秒后自动关闭
                        });
                        return;
                    }
                    if (!vmData.msgAuthCode) {
                        fox.layer.open({
                            content: '验证码不能为空'
                            ,skin: 'msg'
                            ,anim:'up'
                            ,time: 2 //2秒后自动关闭
                        });
                        return;
                    }
                    fox.service.request({
                        id:"forgetPassword",
                        name:"customer/customer/forgetPassword",
                        data:{
                            phone:vmData.forgetPhoneNum,
                            smsCode:vmData.msgAuthCode,
                            codeType:"3"
                        },
                        callback:function(code, message, data){
                            if (code == 0 || code == undefined) {
                                // data=JSON.stringify(data);
                                var forgetPhoneNum = {
                                    forgetPhoneNum:vmData.forgetPhoneNum,
                                }
                                if (data.code == "0") {
                                    //修复ios返回页面光标消失缓慢
                                    var inputs = $('input');
                                    inputs.each(function (i, input) {
                                        input.blur();
                                    });
                                    fox.router.append(id,forgetPhoneNum);
                                } else {

                                    fox.layer.open({
                                        content: data.msg
                                        ,skin: 'msg'
                                        ,anim:'up'
                                        ,time: 2 //2秒后自动关闭
                                    });
                                }
                            } else {
                                fox.layer.open("网络异常");
                            }

                        }
                    })
                },
                //回退
                back:function(){
                    clearTimeout(clear_time);
                    fox.router.remove();
                },
                //调整page size
                adjustPageSize: function adjustPageSize() {
                    //屏幕当前的高度
                    var oHeight = $.getClientHeight();
                    //设置page 高度
                    $(".fox-page > .fox-content").css("height", oHeight+"px");
                },
                //时间倒计时
                onTimeChange:function () {
                    this.m_count--;
                    this.m_verify_tip=`${this.m_count}s`;
                    if(this.m_count == 0)
                        this.onTimeStop();
                },
                //时间倒计时结束
                onTimeStop:function(){
                    this.m_count = "";
                    this.m_disabled = false;
                    this.m_verify_tip="获取验证码"
                    vmData.autBtnClick = true;
                    clearInterval(this.m_intervalId);
                },
                //发送短信验证码
                sendMsgAuthCode:function(){
                    let that = this;
                    if ( vmData.autBtnClick == true) {
                        if(!(/^1[1-9]\d{9}$/.test(vmData.forgetPhoneNum))){
                            fox.layer.open({
                                content: '请输入正确的手机号码'
                                ,skin: 'msg'
                                ,anim:'up'
                                ,time: 2 //2秒后自动关闭
                            });
                            return;
                        }

                        fox.service.request({
                            id: "getAudit",
                            name: "customer/customer/getAudit",
                            data: {
                                phone: vmData.forgetPhoneNum,
                                //     codeType: "1"
                            },
                            callback: function (code, message, data) {
                                if (code == 0 || code == undefined) {
                                    if (data.code == "0") {
                                        fox.service.request({
                                            id:"sendMPSC200Service",
                                            name:"customer/customer/sendMPSC200Service",
                                            data:{
                                                phone:vmData.forgetPhoneNum,
                                                codeType:"3",
                                                toolsDate:data.toolsDate ,
                                                toolsPhones: data.toolsPhones,
                                            },
                                            callback:function(code, message, data){
                                                if (code == 0 || code == undefined) {
                                                    if (data.code == "0") {
                                                        vmData.autBtnClick = false;
                                                        if(that.m_disabled){
                                                            return;
                                                        }
                                                        that.m_count = 60;
                                                        that.m_disabled = true;
                                                        that.m_verify_tip=`${that.m_count}s`;
                                                        that.m_intervalId = setInterval(()=>{
                                                            that.onTimeChange();
                                                        },1000);
                                                        fox.layer.open({
                                                            content: '验证码发送成功'
                                                            ,skin: 'msg'
                                                            ,anim:'up'
                                                            ,time: 2 //2秒后自动关闭
                                                        });
                                                    } else {

                                                        fox.layer.open({
                                                            content: data.msg
                                                            ,skin: 'msg'
                                                            ,anim:'up'
                                                            ,time: 2 //2秒后自动关闭
                                                        });
                                                    }
                                                } else {
                                                    fox.layer.open("网络异常");
                                                }

                                            }
                                        })
                                    } else {
                                        fox.layer.open(data.msg);
                                    }
                                } else {
                                    fox.layer.open("网络异常");
                                }

                            }
                        })


                    }else {

                    }
                },
            },
            //加载后处理
            mounted:function(){
                this.adjustPageSize();
                var input=$(".forget-input-row input");
                clear_time=setTimeout(function () {
                    input[0].focus();
                },100);
            }
        });
    };

    //消息处理
    exports.onmessage = function (type, message, cite) {

    };

    //page销毁时触发destroy方法
    exports.destroy = function (id, cite) {
        clearTimeout(clear_time);
        //修复ios返回页面光标消失缓慢
        var inputs = $('input');
        inputs.each(function (i, input) {
            input.blur();
        });
    }
});
