define(function (require, exports) {

    //page加载完成后调用ready方法
    exports.ready = function (code, data, cite) {
        //vue data
        var vmData = {
            //预约时间的数组
            appointmentDate: [],
            table_header: [{text: "", style: "text-align:left;width:25%;height:8px", columnStyle: "width:25%;"},
                {text: "", style: "text-align:left;width:75%;height:8px", columnStyle: "width:75%;"}],
            doctorList: [],
            departmentList: [{department: "全部"}],
            departmentTypeList: [],
            activeClass: 0,
            hospital_name: data.hospital_name,
            hospital_id: data.hospital_id,
            append_time:'',
            activeClass_left:0,
            nucleicTest:data
        }

        //创建vue model
        let vm = new Vue({
            el: cite.el,
            //数据
            data: vmData,


            //方法
            methods: {
                //日期选择
                selectDate: function (index) {
                    let that = this;
                    vmData.Day = vmData.appointmentDate[index].myDate;
                    that.getDepartment(vmData.Day);
                    vmData.activeClass = index;

                },
                //动态切换选中颜色样式
                selectDepartment: function (index) {
                    this.activeClass_left = index;
                },
                //选择科室
                selectDepartmentType: function (index) {
                    //重复点击修复
                    var append_once=fox.bus.get("append_once");
                    var now_time=new Date();
                    now_time=now_time.getTime();
                    if(append_once==true||now_time-vmData.append_time<1500){
                        vmData.append_time=now_time;
                        return;
                    };
                    vmData.append_time=now_time;
                    fox.bus.put("append_once",true);
                    var departmentData = vmData.departmentTypeList[index];
                    departmentData.date = vmData.Day;
                    departmentData.nucleicTest = vmData.nucleicTest;
                    fox.router.append("east_appointmentRegistration", departmentData);
                },
                getDepartment: function (Day) {
                    var myDate = vmData.appointmentDate[0].myDate;
                    fox.service.request({
                        id: "queryDepartment",
                        name: "service/eastSoftRegistered/queryDepartment",
                        data: {
                            RegType: "2",
                            hospital_id: vmData.hospital_id,
                            Date: Day !== undefined ? Day : myDate,
                            nucleicTest:vmData.nucleicTest
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000"||data.code==undefined) {
                                    vmData.departmentTypeList = '';
                                    fox.layer.open(data.msg);
                                } else {
                                    data.result=data.result==undefined?{DeptList:[]}:data.result;
                                    if(data.result.hasOwnProperty('DeptList')){

                                        if(data.result.DeptList.length==0) {
                                            fox.layer.open("该时段没有可挂号科室");
                                        }
                                        vmData.departmentTypeList = data.result.DeptList;
                                    }else{
                                        vmData.departmentTypeList = '';
                                        fox.layer.open("该时段没有可挂号科室");
                                    }

                                }
                            } else {
                                fox.layer.open("网络异常");
                            }
                        }
                    });
                },
                getmyDate: function () {
                    var now = new Date();
                    var nowTime = now.getTime();
                    var oneDayTime = 24 * 60 * 60 * 1000;
                    var list = [];

                    for (var i = 0; i < 60; i++) {
                        //显示周一
                        var ShowTime = nowTime + (i + 1) * oneDayTime;
                        //初始化日期时间
                        var myDate = new Date(ShowTime);
                        var year = myDate.getFullYear();
                        var month = myDate.getMonth() + 1;
                        var date = myDate.getDate();
                        if (month < 10) {
                            month = "0" + month;
                        }
                        if (date < 10) {
                            date = "0" + date;
                        }
                        // console.log(year+"-"+month+"-"+date);
                        var date = year + "-" + month + "-" + date;
                        var week = "周" + "日一二三四五六".charAt(myDate.getDay());
                        // console.log(week);
                        var makeTime = {
                            myDate: date,
                            date: date.substring(5, 10),
                            week: week
                        }
                        list.push(makeTime);
                    }
                    vmData.appointmentDate = list;
                    setTimeout(function () {
                        var eastSoftSwiper = new Swiper('#eastSoftSwiper',{
                            spaceBetween: 0,
                            slidesPerView : 5,
                        });
                    },300)
                },
                //回退
                back: function () {
                    fox.bus.put("append_once", false);
                    fox.router.remove();
                }
            },
            //加载后处理
            mounted: function () {
                var Dat = new Date();
                Dat.setDate(Dat.getDate() + 1);
                this.getmyDate();
                var Da = vmData.appointmentDate[0].myDate;
                this.getDepartment(Da);
                // fox.localStorage.remove("_global_loginInfo");
                $('.fox-switch').switch();

                $(this.$refs.phoneSwitch).on('toggle', (event) => {
                    this.remPhone = event.detail.isActive
                });

                $(this.$refs.userSwitch).on('toggle', (event) => {
                    this.remUser = event.detail.isActive
                });

            }
        });
    };

    //消息处理
    exports.onmessage = function (type, message, cite) {

    };

    //page销毁时触发destroy方法
    exports.destroy = function (id, cite) {
        fox.bus.put("append_once", false);
    }
});
