/**
 * Created by jiangcheng on 2018/03/06.
 */
define(function (require, exports) {

    //page加载完成后调用ready方法
    exports.ready = function (code, data, cite) {
        var hospitalData = fox.bus.get("hospitalData");
        let vmData = {
            //预约时间的数组
            appointmentDate: [],
            table_header: [{text: "", style: "text-align:left;width:25%;height:8px", columnStyle: "width:25%;"},
                {text: "", style: "text-align:left;width:75%;height:8px", columnStyle: "width:75%;"}],
            doctorList: [],
            DeptName: data.DeptName,//科室名称
            ID: data.ID,//科室ID
            Day: new Date().format("yyyy-MM-dd"),
            hospital_name: data.hospital_name,
            hospital_id: data.hospital_id,
            activeClass:0,
            LockPass:"",
            RegisteredDate:[],
            nucleicTest:data.nucleicTest
        }


        //创建vue model
        let vm = new Vue({
            el:"#east_appointmentRegistration",
            //数据
            data: vmData,
            // 计算属性的 getter
            myPrice: function () {
                // `this` 指向 vm 实例
                var price = vmData.Price;
                return this.myPrice = parseFloat(price).toFixed(2);
            },
            //方法
            methods: {
                back: function () {
                    console.log("返回");
                    // history.back(-1);
                    fox.router.remove();
                },
                //日期选择
                selectDate: function (index) {
                    let that = this;
                    vmData.Day = vmData.appointmentDate[index].myDate;
                    that.getDoctor(vmData.Day);

                },
                //查看挂号医生详情
                lookDoctor: function (index) {

                    if(vmData.doctorList[index].RegCount > 0){
                        let that = this;
                        var doctorDetail = vmData.doctorList[index];
                        doctorDetail.RegType='2';
                        doctorDetail.nucleicTest = vmData.nucleicTest;
                        fox.router.append("east_doctorIntroduction",doctorDetail);
                    }else{
                        fox.layer.open("此号源已被预约，请您预约其他时段号源");

                    }
                    // let that = this;
                    // var doctorDetail = vmData.doctorList[index];
                    // doctorDetail.RegType='2';
                    // doctorDetail.nucleicTest = vmData.nucleicTest;
                    // fox.router.append("east_doctorIntroduction",doctorDetail);
                },
                //获取挂号医生
                getDoctor: function (Day) {
                    var myDate = vmData.appointmentDate[vmData.activeClass].myDate;
                    fox.service.request({
                        id: "queryDoctor",
                        name: "service/eastSoftRegistered/queryDoctor",
                        data: {
                            RegType:'2',
                            Date: Day !== undefined ? Day : myDate,
                            ID:vmData.ID,
                            nucleicTest:vmData.nucleicTest
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000" ||data.code==undefined) {
                                    vmData.doctorList = "";
                                    fox.layer.open(data.msg);
                                } else {
                                    if(data.result.hasOwnProperty('Doctor')){
                                        vmData.doctorList = data.result==undefined?[]:data.result.Doctor;
                                        vmData.doctorList.forEach(function(item,index,arr) {
                                            arr[index].RegCount = Number(item.RegLimit) === 0 ? 2 : Number(item.RegLimit) - Number(item.Reged);
                                        })
                                    }else{
                                        vmData.doctorList = "";
                                        fox.layer.open("没有排班的医生");
                                    }

                                }
                            } else {
                                fox.layer.open("service调用异常:code:" + code + ",msg:" + JSON.stringify(message));
                            }
                        }
                    });
                    fox.bus.put("append_once", false);
                },

                getmyDate: function () {
                    var now = new Date();
                    var nowTime = now.getTime();
                    var oneDayTime = 24 * 60 * 60 * 1000;
                    var list = [];

                    for (var i = 0; i < 60; i++) {
                        //显示周一
                        var ShowTime = nowTime + (i + 1) * oneDayTime;
                        //初始化日期时间
                        var myDate = new Date(ShowTime);
                        var year = myDate.getFullYear();
                        var month = myDate.getMonth() + 1;
                        var date = myDate.getDate();
                        if (month < 10) {
                            month = "0" + month;
                        }
                        if (date < 10) {
                            date = "0" + date;
                        }
                        // console.log(year+"-"+month+"-"+date);
                        var date = year + "-" + month + "-" + date;
                        var week = "周" + "日一二三四五六".charAt(myDate.getDay());
                        // console.log(week);
                        var makeTime = {
                            myDate: date,
                            date: date.substring(5, 10),
                            week: week
                        }
                        list.push(makeTime);
                    }
                    vmData.appointmentDate = list;
                    setTimeout(function () {
                        var appointmentRegistrationSwiper2 = new Swiper('#appointmentRegistrationSwiper2',{
                            spaceBetween: 0,
                            slidesPerView : 5,
                        });
                        appointmentRegistrationSwiper2.slideTo(vmData.activeClass, 1000, false);//切换到第一个slide，速度为1秒
                    },300)


                },

                //路由跳转
                to: function (id) {
                    fox.router.append(id);
                },
                //记录跳转过来的日期
                init:function () {
                    for(var i=0;i<vmData.appointmentDate.length;i++) {
                        if(vmData.appointmentDate[i].myDate==data.date){
                            vmData.activeClass=i;
                        }
                    }
                }
            },
            //加载后处理
            mounted: function () {
                var Dat=new Date();
                Dat.setDate(Dat.getDate()+1);
                this.getmyDate();
                this.init();
                this.getDoctor(data.date);

            },
            //销毁前
            beforeDestroy: function () {

            }
        });


    };

    //消息处理
    exports.onmessage = function (type, message, cite) {

    };

    //page销毁时触发destroy方法
    exports.destroy = function (id, cite) {

    }
});


