define(function (require, exports) {

    //page加载完成后调用ready方法
    exports.ready = function (code, data, cite) {
        //vue data
        var phone = fox.bus.get("loginPhoneNum");
        var loginInfo = fox.bus.get("loginUserInfo");
        var hospitalData = fox.bus.get("HomehospitalData");
        var vmData = {
            m_select_items: [],
            patient:"",
            Ofpatient: "",
            PatientID:"",
            pid:"",
            DeptName: data.DeptName,   // 门诊名称
            BeginTime:data.BeginTime ,  // 开始时间
            EndTime: data.EndTime,      //  结束时间
            Fee:data.Fee,               //  总费用
            Noon:data.Noon,             //  上午下午晚上
            IDCardNo:loginInfo == undefined ? "" : loginInfo.card_number,
            user_id:loginInfo == undefined ? "" : loginInfo.user_id,//用户userid
            PatientName:"",
            CardNo:"",
            phone:phone,
            SchemaID:data.SchemaID,
            hospital_id:hospitalData.hospital_id,
            hospital_name:hospitalData.hospital_name,
            ReglevelName:data.ReglevelName,      //  医生级别
            DoctorName:data.DoctorName,
            Time:data.BeginTime+" --"+data.EndTime.split(" ")[1],
            Day:data.BeginTime.replace(/\//g,'-'),
            timeKey:data.TimeKey,   //  时间段参数
            Time1:data.BeginTime+"  "+data.TimeKey,
            RegType:data.RegType,         // 当日还是预约
            timeValue:data.timeValue
        }

        //创建vue model
        let vm = new Vue({
            el: cite.el,
            //数据
            data: vmData,
            computed: {
                // 计算属性的 getter
                myPrice: function () {
                    // `this` 指向 vm 实例
                    var price = vmData.Price;
                    return this.myPrice=parseFloat(price).toFixed(2);
                }
            },
            //方法
                methods: {
                //下一步
                east_nextStep: function () {
                    let that = this;
                    if (vmData.patient == "" || vmData.patient == undefined) {
                        fox.layer.open("请选择就诊人");
                        return;
                    } else {
                        fox.layer.open({
                            content: "请确认就诊人:<span style='color: #fe3632'>"+vmData.Ofpatient+"</span>"
                            , btn: ['取消', '确认']
                            , action: [
                                function (index) {
                                    //取消
                                    fox.layer.close(index);
                                },
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                function (index) {
                                    //确定
                                    fox.layer.close(index);
                                                        var ca={
                                                            Fee:vmData.Fee,                 // 所需费用
                                                            pid:vmData.pid,                 // pid
                                                            Ofpatient:vmData.Ofpatient,    // 病人名称
                                                            CardNo:vmData.CardNo,           //  卡号
                                                            ReglevelName:vmData.ReglevelName,     // 医生级别
                                                            Noon:vmData.Noon,                 //上午下午晚上
                                                            DoctorName:vmData.DoctorName,      // 医生姓名
                                                            DeptName:vmData.DeptName,           // 科室名称
                                                            Time:vmData.Time,
                                                            SchemaID: vmData.SchemaID,
                                                            Day:vmData.Day,
                                                            RegType:vmData.RegType,    // 当日还是预约
                                                            timeKey:vmData.timeKey,      // 预约时段参数
                                                            timeValue:vmData.timeValue   // 是否需要走锁号标识
                                                         }
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                        fox.router.append("east_confirmPayment", ca);
                                }
                            ]
                        })
                    }
                },
                // 建卡（有身份证）
                east_SignUp1:function(){
                    fox.service.request({
                        id: "SignUp1",
                        name: "service/eastSoftRegistered/SignUp1",
                        data: {
                                // 需传身份证号和姓名
                            IDCardNo: vmData.IDCardNo,   // 身份证号
                            Ofpatient:vmData.Ofpatient,  // 姓名
                            pid:vmData.pid,          //  就诊人id
                            hospital_id:vmData.hospital_id,
                            hospital_name:vmData.hospital_name
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000") {
                                    fox.layer.open(data.msg);
                                } else if(data.flag == undefined){

                                    vmData.CardNo=data.card;
                                }else {
                                    if(data.flag == '1'){
                                        fox.layer.open('用户姓名与身份证号不匹配，请去窗口办理更改手续');
                                    }
                                }
                            } else {
                                fox.layer.open("service调用异常:code:" + code + ",msg:" + JSON.stringify(message));
                            }
                        }
                    });
                },
                    //无身份证办卡
                    east_SignUp2:function(){
                        fox.service.request({
                            id: "SignUp2",
                            name: "service/eastSoftRegistered/SignUp2",
                            data: {
                                Ofpatient:vmData.Ofpatient,  // 姓名
                                pid:vmData.pid,          //  就诊人id
                                hospital_id:vmData.hospital_id,
                                hospital_name:vmData.hospital_name
                            },
                            callback: function (code, message, data) {
                                if (code == 0 || code == undefined) {
                                    if (data.code == "200000") {
                                        fox.layer.open(data.msg);
                                    }else {
                                        vmData.CardNo=data.card;
                                    }
                                } else {
                                    fox.layer.open("service调用异常:code:" + code + ",msg:" + JSON.stringify(message));
                                }
                            }
                        });


                    },

                //查询就诊人
                east_queryOfpatient: function () {
                    let that = this;
                    fox.service.request({
                        id: "getPactionListByHis",
                        name: "pation/pation/getPactionListByHis",
                        data: {
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000") {
                                    fox.layer.open(data.msg);
                                } else {
                                    var dataList = data.data;
                                    for (let i in dataList) {
                                        var myData = {
                                            value: dataList[i].patient_number,   // 就诊人身份证号
                                            text: dataList[i].patient_name,      // 就诊人名称
                                            pid: dataList[i].pid,       // 就诊人pid
                                            CardNo:dataList[i].card_no,   //  就诊人卡号
                                        }

                                        var checkPidInfo=fox.sessionStorage.get("checkPidInfo");
                                        console.log("checkPidInfo"+checkPidInfo);
                                        if(checkPidInfo == undefined || checkPidInfo == ""){
                                            vmData.m_select_items.push(myData);
                                        }else{
                                            if (checkPidInfo == myData.pid){
                                                vmData.m_select_items.push(myData);
                                            }
                                        }
                                    }
                                    if (vmData.m_select_items.length > 0) {
                                        vmData.patient = vmData.m_select_items[0];
                                        vmData.Ofpatient = vmData.m_select_items[0].text;
                                        vmData.IDCardNo = vmData.m_select_items[0].value;
                                        vmData.pid = vmData.m_select_items[0].pid;
                                        vmData.CardNo = vmData.m_select_items[0].CardNo;
                                        if((vmData.CardNo == undefined||vmData.CardNo =='')&&(vmData.IDCardNo==undefined||vmData.IDCardNo=='')){
                                                that.east_SignUp2();        // 无身份证小孩就医办卡

                                        }else  if(vmData.CardNo==undefined||vmData.CardNo==''){
                                            that.east_SignUp1();       // 有身份证就医办卡
                                        }

                                    }
                                }
                            } else {
                                fox.layer.open("service调用异常:code:" + code + ",msg:" + JSON.stringify(message));
                            }
                        }
                    });
                },
                //选择就诊人
                east_select: function (evt) {//底部弹出下拉框-预留
                    let that = this;
                    if (evt != undefined) {
                        vmData.Ofpatient = evt.items[0].text;
                        vmData.IDCardNo = evt.items[0].value;
                        vmData.pid = evt.items[0].pid;
                        vmData.CardNo = evt.items[0].CardNo;
                        if((evt.items[0].CardNo==undefined||evt.items[0].CardNo=='')&&(evt.items[0].value == undefined||evt.items[0].value =='')){
                            that.east_SignUp2();
                        }else if(evt.items[0].CardNo==undefined||evt.items[0].CardNo==''){
                            that.east_SignUp1();
                        }
                    }

                },
                getCode: function () {

                },

                //回退
                back: function () {
                    fox.router.remove();
                }
            },
            //加载后处理
            mounted: function () {
                this.east_queryOfpatient();
                // fox.localStorage.remove("_global_loginInfo");
                $('.fox-switch').switch();

                $(this.$refs.phoneSwitch).on('toggle', (event) => {
                    this.remPhone = event.detail.isActive
                });

                $(this.$refs.userSwitch).on('toggle', (event) => {
                    this.remUser = event.detail.isActive
                });

            }
        });
    };

    //消息处理
    exports.onmessage = function (type, message, cite) {

    };

    //page销毁时触发destroy方法
    exports.destroy = function (id, cite) {

    }
});
