define(function (require, exports) {

    //page加载完成后调用ready方法
    exports.ready = function (code, data, cite) {
        //vue data
        var vmData={
            DeptName:data.Name, //科室名称
            DeptId:data.ID,     //科室ID
            doctorList:[],
            Date:new Date().format("yyyyMMdd"),
            nucleicTest:data.nucleicTest

        }

        //创建vue model
        let vm=new Vue({
            el:cite.el,
            //数据
            data:vmData,

            //方法
            methods:{
                //查看挂号医生详情
                east_lookDoctor: function (index) {
                if(vmData.doctorList[index].RegCount > 0){
                        var doctorDetail = vmData.doctorList[index];
                        doctorDetail.RegType='1';
                        doctorDetail.nucleicTest = vmData.nucleicTest;
                        fox.router.append("east_doctorIntroduction",doctorDetail);
                  }else{
                        fox.layer.open("此号源已被预约，请您预约其他时段号源");
                  }
             },
                east_getDoctor:function () {
                    fox.service.request({
                        id: "queryDoctor",
                        name: "service/eastSoftRegistered/queryDoctor",
                        data: {
                            RegType:'1',
                            ID: vmData.DeptId,
                            Date:vmData.Date,
                            nucleicTest:vmData.nucleicTest
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000") {
                                    vmData.doctorList = "";
                                    fox.layer.open(data.msg);
                                } else {
                                    if(data.result.hasOwnProperty('Doctor')){
                                        vmData.doctorList = data.result==undefined?[]:data.result.Doctor;
                                        vmData.doctorList.forEach(function(item,index,arr) {
                                            arr[index].RegCount = Number(item.RegLimit) === 0 ? 2 : Number(item.RegLimit) - Number(item.Reged);
                                        })
                                    }else{
                                        vmData.doctorList = "";
                                        fox.layer.open("没有排班的医生");
                                    }
                                }
                            } else {
                                fox.layer.open("service调用异常:code:" + code + ",msg:" + JSON.stringify(message));
                            }
                            fox.bus.put("append_once",false);
                        }
                    });
                },
                //回退
                back: function () {
                    fox.router.remove();
                }
            },
            //加载后处理
            mounted:function(){
                this.east_getDoctor();
                // fox.localStorage.remove("_global_loginInfo");
                $('.fox-switch').switch();

                $(this.$refs.phoneSwitch).on('toggle',(event)=>{
                    this.remPhone = event.detail.isActive
            });

                $(this.$refs.userSwitch).on('toggle',(event)=>{
                    this.remUser = event.detail.isActive
            });

            }
        });
    };

    //消息处理
    exports.onmessage = function (type, message, cite) {

    };

    //page销毁时触发destroy方法
    exports.destroy = function (id, cite) {

    }
});
