/**
 * Created by hukun on 2019/05/28.
 */
define(function (require, exports) {
    var clear_time;
    //page加载完成后调用ready方法
    exports.ready = function (code, data, cite) {

        let vmData = {
            oldPassword: "",
            firstNewPassword: "",
            secoundNewPassword: ""
        };

        //创建vue model
        let vm = new Vue({
            el: cite.el,
            //数据
            data: vmData,
            //方法
            methods: {
                //回退
                back: function () {
                    clearTimeout(clear_time);
                    fox.router.remove();
                },
                updatePassword: function () {
                    if (!vmData.oldPassword) {
                        fox.layer.open({
                            content: '请输入旧密码'
                            , skin: 'msg'
                            , anim: 'up'
                            , time: 2 //2秒后自动关闭
                        });
                        return;
                    }

                    if (!(/^(?=.*[A-Za-z])(?=.*\d)[A-Za-z\d]{6,16}$/.test(vmData.firstNewPassword))) {
                        fox.layer.open({
                            content: '请输入6-16位数字与字母组合的密码'
                            , skin: 'msg'
                            , anim: 'up'
                            , time: 2 //2秒后自动关闭
                        });
                        return;
                    }
                    if (!(/^(?=.*[A-Za-z])(?=.*\d)[A-Za-z\d]{6,16}$/.test(vmData.secoundNewPassword))) {
                        fox.layer.open({
                            content: '请再次输入6-16位数字与字母组合的密码'
                            , skin: 'msg'
                            , anim: 'up'
                            , time: 2 //2秒后自动关闭
                        });
                        return;
                    }
                    if (!(vmData.firstNewPassword === vmData.secoundNewPassword)) {
                        fox.layer.open({
                            content: '两次输入密码不一致'
                            , skin: 'msg'
                            , anim: 'up'
                            , time: 2 //2秒后自动关闭
                        });
                        return;
                    }

                    fox.service.request({
                        id: "ResetPasswordPage",
                        name: "customer/customer/ResetPasswordPage",
                        data: {
                            phone: fox.bus.get("loginPhoneNum"),
                            oldpassword: this.encrypt(vmData.oldPassword),
                            newpassword1: this.encrypt(vmData.firstNewPassword),
                            newpassword2: this.encrypt(vmData.secoundNewPassword)

                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                // data=JSON.stringify(data);
                                if (data.code == "0") {
                                    //清空手势登录
                                    fox.custom.clearGestureData();
                                    //修复ios返回页面光标消失缓慢
                                    var inputs = $('input');
                                    inputs.each(function (i, input) {
                                        input.blur();
                                    });
                                    fox.router.append("success_tip");
                                } else {

                                    fox.layer.open({
                                        content: data.msg
                                        , skin: 'msg'
                                        , anim: 'up'
                                        , time: 2 //2秒后自动关闭
                                    });
                                }
                            } else {
                                fox.layer.open("网络异常");
                            }

                        }
                    })
                },
                encrypt: function (word) {
                    var key = CryptoJS.enc.Utf8.parse("yxfoxzsyc");
                    var srcs = CryptoJS.enc.Utf8.parse(word);
                    var encrypted = CryptoJS.AES.encrypt(srcs, key, {
                        mode: CryptoJS.mode.ECB,
                        padding: CryptoJS.pad.Pkcs7
                    });
                    return encrypted.toString();
                },
                //调整page size
                adjustPageSize: function adjustPageSize() {
                    //屏幕当前的高度
                    var oHeight = $.getClientHeight();
                    //设置page 高度
                    $(".fox-page > .fox-content").css("height", oHeight + "px");
                }

            },
            //加载后处理
            mounted: function () {
                //调整页面大小
                this.adjustPageSize();
                $('.fox-input-row input').input();
                var inputs = $('.fox-input-row input');
                clear_time = setTimeout(function () {
                    inputs.each(function (i, input) {
                        if (i == 0) {
                            input.focus();
                        }
                        // console.log("============" + i);
                        input.style.pointerEvents = "auto";
                    });
                }, 400);
            }
        });
    };

    //消息处理
    exports.onmessage = function (type, message, cite) {

    };

    //page销毁时触发destroy方法
    exports.destroy = function (id, cite) {
        clearTimeout(clear_time);

        //修复ios返回页面光标消失缓慢
        var inputs = $('input');
        inputs.each(function (i, input) {
            input.blur();
        });
    }
});
