define(function (require, exports) {

    //page加载完成后调用ready方法
    exports.ready = function (code, data, cite) {
        var phone = fox.bus.get("loginPhoneNum");
        var loginInfo = fox.bus.get("loginUserInfo");
        var hospitalData = fox.bus.get("HomehospitalData");
        var loginDeviceType = fox.bus.get("loginDeviceType");
        var vmData = {
            paymentType: "",//1微信支付2支付宝支付
            maxtime: 1 * 60,
            minutes: "",//分
            seconds: "",//秒
            Ofpatient: data.Ofpatient,    // 病人姓名
            pid:data.pid,                 //  病人pid
            CardNo: data.CardNo,          //  病人卡号
            Sex: data.Sex,
            DeptID: data.DeptID,          //
            RegType: data.RegType,        // 当日
            DepName: data.DepName,
            IDCardNo: loginInfo == undefined ? "" : loginInfo.card_number,//身份证号
            user_id: loginInfo == undefined ? "" : loginInfo.user_id,//用户userid
            user_phone: phone,//用户手机
            hospital_name: hospitalData.hospital_name,//医院名称
            hospital_id: hospitalData.hospital_id,//医院id
            wx_status:hospitalData.wx_status,
            pay_serail: "",//支付流水
            loginDeviceType: loginDeviceType,//系统类型
            Fee:data.Fee,
            Day:new Date().format("yyyyMMdd"),
            DoctorName:data.DoctorName,
            ReglevelName:data.ReglevelName,    // 出诊级别
            Noon:data.Noon,
            Price:data.topUpMonery
        }

        //创建vue model
        let vm = new Vue({
            el: cite.el,
            //数据
            data: vmData,
            computed: {
                // 计算属性
                myPrice: function () {
                    // `this` 指向 vm 实例
                    var price = vmData.Price;
                    return this.myPrice = parseFloat(price).toFixed(2);
                }
            },


            //方法
            methods: {
                //去支付开始
                goPayment: function () {
                    let that = this;
                    vmData.registerData = {
                        PatName: vmData.Ofpatient,
                        PatientID: "",
                        RegType:vmData.RegType,
                        CardTypeID: "",
                        Day: vmData.Day,
                        CardNo: vmData.CardNo,
                        VisitID:"",
                        MarkDesc: vmData.DoctorName,  //  医生姓名
                        SessionType: vmData.ReglevelName,
                        HBTime:vmData.Noon
                    }
                    var payType = vmData.paymentType;
                    if (payType === "1" && payType !== "") {
                        that.wxPay(payType, vmData.registerData);
                    } else if (payType === "2" && payType !== "") {
                        that.zfbPay(payType, vmData.registerData);
                    }
                },
                //微信支付
                wxPay: function (payType, registerData) {
                    let that = this;
                    fox.service.request({
                        id: "getPaymentOrder",
                        name: "wxpay/wxpay/getPaymentOrder",
                        data: {
                            payType: payType,
                            PatientID: vmData.pid,
                            total_amount: "0.01",
                            body: "微信充值",
                            subject: "医院收费",
                            chnlcode:"001",
                            registerData: registerData //挂号明细
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000") {
                                    fox.layer.open(data.msg);
                                } else {
                                    var outtradeno = data.outtradeno;//订单号
                                    //开始调取支付
                                    that.WXhtml(payType, outtradeno, data);
                                }
                            } else {
                                fox.layer.open("网络异常");
                            }
                        }
                    });
                },
                //支付宝支付
                zfbPay: function (payType, registerData) {
                    let that = this;
                    fox.service.request({
                        id: "getPaymentOrder",
                        name: "alipay/alipay/getPaymentOrder",
                        data: {
                            payType: payType,
                            PatientID: vmData.pid,
                            total_amount: "0.01",
                            body: "支付宝充值",
                            subject: "医院收费",
                            chnlcode:"001",
                            registerData:registerData  //挂号明细
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000") {
                                    fox.layer.open(data.msg);
                                } else {
                                    var outtradeno = data.outtradeno;//订单号
                                    //开始调取支付
                                    that.ZFBhtml(payType, outtradeno, data);
                                }
                            } else {
                                fox.layer.open("网络异常");
                            }
                        }
                    });
                },
                //微信支付页面调取
                WXhtml: function (payType, outtradeno, data) {
                    let that = this;
                    if (vmData.loginDeviceType === "android") {
                        console.log("android");
                        var params = data.data;
                        fox.native.call("wxPay", params, function (code, message, data) {
                            if (code == 0) {
                                /** obj字典参数 :
                                 * 错误码：errCode
                                 * 错误提示字符串：errStr
                                 *响应类型：type
                                 * */
                                var obj = JSON.parse(data);
                                if (obj.errCode === "0") {
                                    fox.layer.open("支付成功");//支付成功
                                    //查询异步支付结果
                                    that.WXOrder(payType, outtradeno,obj);
                                } else {
                                    fox.layer.open("支付失败");//支付失败
                                }
                            } else {
                                fox.layer.open(message);
                            }
                        });
                    } else if (vmData.loginDeviceType === "ios") {
                        console.log("ios");
                        var params = fox.base64.encode(data.data);
                        fox.device.callWXPay("callWXPay", params, function (code, message, data) {
                            if (code == 0) {
                                var callBackParams = fox.base64.decode(data);
                                /** obj字典参数 :
                                 * 错误码：errCode
                                 * 错误提示字符串：errStr
                                 *响应类型：type
                                 * */
                                var obj = JSON.parse(callBackParams);
                                if (obj.errCode === "0") {
                                    fox.layer.open("支付成功");//支付成功
                                    //查询异步支付结果
                                    that.WXOrder(payType, outtradeno,callBackParams);
                                } else {
                                    fox.layer.open("支付失败");//支付失败
                                }
                            } else {
                                fox.layer.open(message);

                            }
                        });
                    }
                },
                //支付宝页面调取
                ZFBhtml: function (payType, outtradeno, data) {
                    let that = this;
                    console.log(vmData.loginDeviceType);
                    if (vmData.loginDeviceType === "android") {
                        console.log("android");
                        var params = data.data;
                        fox.native.call("aliPay", params, function (code, message, data) {
                            if (code == 0) {
                                var callBackParams = JSON.parse(data);
                                if (callBackParams.resultStatus === "9000") {
                                    //查询异步支付结果
                                    that.ZFBOrder(payType, outtradeno,callBackParams);
                                } else {
                                    fox.layer.open(dataStatus.memo);//支付失败

                                }

                            } else {
                                fox.layer.open(message);

                            }
                        });
                    } else if (vmData.loginDeviceType === "ios") {
                        console.log("ios");
                        var params = fox.base64.encode(data.data);
                        fox.device.callAliPay("callAliPay", params, function (code, message, data) {
                            if (code == 0) {
                                var callBackParams = fox.base64.decode(data);
                                var obj = JSON.parse(callBackParams);
                                if (obj.resultStatus === "9000") {
                                    //查询异步支付结果
                                    that.ZFBOrder(payType, outtradeno,callBackParams);
                                } else {
                                    fox.layer.open(obj.memo);//支付失败
                                }

                            } else {
                                fox.layer.open(message);
                            }
                        });
                    }
                },
                // 支付宝异步查询
                ZFBOrder: function (payType, outtradeno,callBackParams) {
                    let that = this;
                    fox.service.request({
                        id: "getOrderQuery",
                        name: "alipay/alipay/getOrderQuery",
                        data: {
                            out_trade_no: outtradeno,
                            // idBack:vm.idBack.image,
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000") {
                                    //that.unlock();
                                } else if(data.code  == "0" && data.status == "1") {
                                    // 开始提交挂号
                                    console.log(outtradeno);
                                    that.Recharge("zfb",outtradeno,"0.01");
                                } else {

                                }
                            } else {
                                // 请稍后查询
                            }
                        }
                    });
                },

                // 微信异步查询
                WXOrder: function (payType, outtradeno,callBackParams) {
                    let that = this;
                    fox.service.request({
                        id: "orderquery",
                        name: "wxpay/wxpay/orderquery",
                        data: {
                            out_trade_no: outtradeno,
                            // idBack:vm.idBack.image,
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000") {
                                    // 服务失败
                                } else if(data.code  == "0" && data.status == "1") {
                                    // 充值，挂号
                                    that.Recharge("wx",outtradeno,"0.01");
                                } else {
                                    //
                                }
                            } else {
                                // 查询失败
                            }
                        }
                    });
                },
                //  充值
                Recharge: function(BankName,FlowNo,Amt){
                    let that = this;
                    fox.service.request({
                        id: "recharge",
                        name: "service/eastSoftRegistered/recharge",
                        data: {
                            CardNo:vmData.CardNo,
                            FlowNo:FlowNo,
                            Amt:Amt,
                            BankName:BankName,
                            BankNo:"00123123414",

                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {

                                if (data.code == "0") {
                                    // 充值成功
                                    console.info("his充值成功");
                                    that.changSetatus(FlowNo,"1");
                                }else{
                                    // 充值失败

                                }
                            } else {
                                fox.layer.open("网络异常");
                            }
                        }

                    })
                },
                //  挂号
                // Guahao: function(FlowNo){
                //     let that = this;
                //     fox.service.request({
                //         id: "submitOrder",
                //         name: "service/eastSoftRegistered/submitOrder",
                //         data: {
                //             CardNo:vmData.CardNo,
                //             SchemaID: vmData.SchemaID,
                //         },
                //         callback: function (code, message, data) {
                //             if (code == 0 || code == undefined) {
                //
                //                 if (data.code == "0") {
                //
                //                     if (data.Result=="1"){
                //                         that.changSetatus(FlowNo,"1");
                //                         fox.router.append("registeredSuccessfully");
                //                     }
                //
                //
                //                 }
                //             } else {
                //                 fox.layer.open("网络异常");
                //             }
                //         }
                //
                //     })
                // },
                // 修改最终状态
                changSetatus:function(outtradeno,busistatus){
                    fox.service.request({
                        id: "changSetatus",
                        name: "service/eastSoftRegistered/changSetatus",
                        data: {
                            outtradeno:outtradeno,
                            busistatus:busistatus
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {

                            } else {
                                fox.layer.open("网络异常");
                            }
                        }

                    })


                },
                // 退款
                /*getOrderRefund: function (outtradeno) {
                    //hospital_id=lysdyzyy0001&out_trade_no=201906211649467722310219&refund_amount=0.01
                    fox.service.request({
                        id: "getOrderRefund",
                        name: "alipay/alipay/getOrderRefund",
                        data: {
                            hospital_id: vmData.hospital_id,
                            out_trade_no: outtradeno,
                            refund_amount: vmData.Price,
                            // idBack:vm.idBack.image,
                        },
                        callback: function (code, message, data) {
                            if (code == 0 || code == undefined) {
                                if (data.code == "200000") {
                                    fox.layer.open(data.msg);
                                } else {
                                    fox.layer.open("挂号失败,费用预计2-3个工作日将退回原支付账户中!");
                                    // vmData.Registrationrecord = data.list;alipay/alipay/getOrderRefund.
                                }
                            } else {
                                fox.layer.open("退款异常请去首页查询挂号记录查看退款结果");
                            }
                        }
                    });
                },*/
                //选择就诊人
                select: function (evt) {//底部弹出下拉框-预留
                    if (evt != undefined) {
                        vmData.aaaa.text = evt.text;
                        var a = vmData.aaaa;
                    }
                },
                //挂号
                NotesReg: function () {
                    fox.router.append("confirmPayment");
                },

                // CountDown: function () {
                //     if (vmData.maxtime >= 0) {
                //         var m = Math.floor(vmData.maxtime / 60);
                //         var s = Math.floor(vmData.maxtime % 60);
                //         if (s < 10) {
                //             vmData.seconds = "0" + s;
                //
                //         } else {
                //             vmData.seconds = s;
                //         }
                //         if (m < 10) {
                //             vmData.minutes = "0" + m;
                //         } else {
                //             vmData.minutes = m;
                //         }
                //         --vmData.maxtime;
                //     } else {
                //         clearInterval(this.timer);
                //         fox.router.to("school_frame");
                //
                //     }
                // },


                //回退
                back: function () {
                    fox.router.remove();
                    clearInterval(this.timer);
                }
            },
            //加载后处理
            mounted: function () {
                // this.timer = setInterval(CountDown(), 1000);
                // this.timer = setInterval(() => {
                //     this.CountDown();
                // }, 1000);
                // fox.localStorage.remove("_global_loginInfo");
                $('.fox-switch').switch();

                $(this.$refs.phoneSwitch).on('toggle', (event) => {
                    this.remPhone = event.detail.isActive
                });

                $(this.$refs.userSwitch).on('toggle', (event) => {
                    this.remUser = event.detail.isActive
                });

            }
        });
    };

    //消息处理
    exports.onmessage = function (type, message, cite) {

    };

    //page销毁时触发destroy方法
    exports.destroy = function (id, cite) {

    }
});
